;;This file is part of Elfo saves Christmas.

    ;;Elfo saves Christmas is free software: you can redistribute it and/or modify
    ;;it under the terms of the GNU General Public License as published by
    ;;the Free Software Foundation, either version 3 of the License, or
    ;;(at your option) any later version.

    ;;Elfo saves Christmas is distributed in the hope that it will be useful,
    ;;but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;;GNU General Public License for more details.

    ;;You should have received a copy of the GNU General Public License
    ;;along with Elfo saves Christmas.  If not, see <https://www.gnu.org/licenses/>.
.include "render.h.s"
;;
;;  Macros
;; 

;; Esta entity es para los disparos
.macro DefineEntitySimple _name, _x, _y, _vx, _vy, _w, _h, _upd, _distance, _trace
_name: 
    DefineDrawableEntity_Simple _name'_dw, _x, _y, _w, _h ;; caracteristicas comunes enemigo y jugador
   .db   _vx, _vy       ;; VX, VY
   .dw   _upd           ;; Update
   .db  _distance       ;; Distancia que viaja el disparo
_name'_size = . - _name ;; Direccion actual - direccion a la que apunta _name
.endm

;; Las Entidad Lo utilizaremos para enemigos y en player extenderá teniendo más stats
.macro DefineEntity _name, _x, _y, _vx, _vy, _w, _h, _sprite, _upd, _health, _attack 
_name: 
    DefineDrawableEntity _name'_dw, _x, _y, _w, _h, _sprite ;; caracteristicas comunes enemigo y jugador
   .db   _vx, _vy       ;; VX, VY
   .dw   _upd           ;; Update
   .db	_health, _attack
_name'_size = . - _name ;; Direccion actual - direccion a la que apunta _name
.endm

e_de_size_sp = 6 ;; Tamaño de DefineDrawableEntity, incluye sprite
;; Etiquetas entity sprite + sin sprite (simple)
e_de        = 0                 
e_vx        = 0 + e_de_size_sp  e_vy        = 1 + e_de_size_sp
e_up_l      = 2 + e_de_size_sp  e_up_h      = 3 + e_de_size_sp
e_he	    = 4 + e_de_size_sp	 e_at	    = 5 + e_de_size_sp 

;; Etiquetas exclusivas sin sprite (entity simple)
es_de_size  = de_simple_size ;; Tamaño de DefineDrawableEntity_Simple
es_de        = 0                 
es_vx        = 0 + es_de_size  es_vy        = 1 + es_de_size
es_up_l      = 2 + es_de_size  es_up_h      = 3 + es_de_size
es_distance  = 4 + es_de_size   

entity_size = 12        ;; Si añadimos cosas a entity, modificar, utilizado por player.h.s
;; Size de DefineEntity = 12
;; Size de DefineEntitySimple = 9


;; Macros para los enemigos
.macro DefineEntityDefault _name, _suf
   DefineEntity _name'_suf, 0, 0, 0, 0, 4, 16, 0x0000, ent_enemy1_move, 3, 1
.endm

.macro DefineNEntities _name, _n
   _c = 0
   .rept _n
      DefineEntityDefault _name, \_c
      _c = _c + 1
   .endm
.endm

;;
;;  Funciones publicas
;;
.globl ent_draw
.globl ent_clear
.globl ent_update
.globl ent_move         ;; Default Move

.globl ent_move_bullet  ;; Move de disparo
.globl ent_draw_bullet

.globl enemy_reset
.globl enemy_copy
.globl enemy_new
.globl enemy_doThisForAll
.globl enemy_remove_last
.globl enemy_creator_reset
.globl enemy_creator_decrease_Delay
.globl enemy_creator_increase_Health

.globl ent_check_collision

.globl get_current_room
.globl set_current_room

.globl get_enemy_vec

.globl ent_check_colision_player_enemy
.globl ent_check_colision_bullet_enemy
.globl ent_check_collision_entities
.globl ent_loadEnemiesRoom