;;This file is part of Elfo saves Christmas.

    ;;Elfo saves Christmas is free software: you can redistribute it and/or modify
    ;;it under the terms of the GNU General Public License as published by
    ;;the Free Software Foundation, either version 3 of the License, or
    ;;(at your option) any later version.

    ;;Elfo saves Christmas is distributed in the hope that it will be useful,
    ;;but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;;GNU General Public License for more details.

    ;;You should have received a copy of the GNU General Public License
    ;;along with Elfo saves Christmas.  If not, see <https://www.gnu.org/licenses/>.
.include "cpctelera.h.s"
.include "player.h.s" ;; incluye render y entity
;;.include "entity.h.s"
.include "main.h.s"
.include "levels/Rooms1.h.s"

current_room:   .dw 0x0000         ;; Aquí configuramos la habitacion inicial

;; Valor minimo de Enemy Delay Default es 1. 
EnemyDelayDefault   = 5
EnemyHealthDefault  = 2         ;; En el nivel uno hay que disparar 3 veces. Tiene que pasar la vida del enemigo a negativo
var_enemy_delay:            .db #EnemyDelayDefault     ;; Inicialmente lo ponemos a EnemyDelayDefault
var_enemy_delay_counter:    .db #EnemyDelayDefault


;; para la creacion de enemigos al cambiar de habitacion
DefineEntity enemy_creator, 60, 64, 0x00, 0x00, 0x04, 0x10, _movingEnemy1_sp_0, ent_enemy1_move, 3, 1

;; Inmediatos constantes enemigos
max_num_enemies = 6
enemies_size = 12

;; Valores por defecto de enemy
;; DefineEntity _name'_suf, 0, 0, 0, 0, 4, 16, 0x0000, ent_enemy1_move, 3, 1
enemy_vector:
DefineNEntities enemy_vector, max_num_enemies       ;; Vector de enemigos

;; Etiquetas para controlar sistema de enemigos
m_num_enemies:  .db 0               ;; Lleva la cuenta de las entidades creadas
m_next_enemy:   .dw enemy_vector    ;; Puntero a la posición donde se crea nueva entidad
m_aux_enemy:    .dw 0x0000          ;; Usaremos para la eliminacion de enemigos

;; Constantes para los tiles
tile_puerta1        = 25
tile_puerta2        = 33
tile_fondo          = 6
tile_vida           = 9
tile_key            = 8
tile_stairs1        = 10
tile_stairs2        = 11
tile_metralleta     = 12
tile_santa1         = 13
tile_santa2         = 14
tile_santa3         = 15
tile_enemy          = 31

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Resetea el creador de enemigo a como deberia estar 
;; en el nivel 1
;; REGISTROS DESTRUIDOS: A
;; ENTRADA: -
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
enemy_creator_reset:
    ld  a, #EnemyDelayDefault
    ld  (var_enemy_delay), a
    ld  (var_enemy_delay_counter), a    ;; Variables de delay puestas al valor por defecto

    push    ix
    ld      ix, #enemy_creator
    ld  e_he(ix), #EnemyHealthDefault   ;; Vida de enemigo puesta a vida por defecto
    pop     ix

    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Decrementa el delay del creador de enemigo para 
;; que se mueva mas rapido
;; REGISTROS DESTRUIDOS: AF
;; ENTRADA: -
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
enemy_creator_decrease_Delay:
    ld      a, (var_enemy_delay)
    dec     a
    jr      nz, decrementamosDelay  ;; Para asegurarnos de nunca poner el delay a 0 y dejar a enemigo practicamente inmobil.
    ret
decrementamosDelay:
    ld  (var_enemy_delay), a         ;; Nuevo valor del delay
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Incrementa la vida del creador de enemigo para que 
;; los enemigos tengan mas vida
;; REGISTROS DESTRUIDOS: AF
;; ENTRADA: -
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
enemy_creator_increase_Health:
    push    ix
    ld      ix,  #enemy_creator
    ld      a, e_he(ix)
    inc     a
    ld  e_he(ix), a
    pop     ix
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Devuelve Vector Enemigos
;; REGISTROS DESTRUIDOS: HL
;; ENTRADA: -
;; SALIDA:  HL -> Puntero vector de enemigos
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
get_enemy_vec:
    ld      hl, #enemy_vector
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Devuelve puntero al tilemap de habitacion actual
;; REGISTROS DESTRUIDOS: HL
;; ENTRADA: -
;; SALIDA:  HL -> Puntero a habitacion actual
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
get_current_room:
    ld      hl, (current_room)        ;; Guardamos la direccion
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Cambia el puntero al tilemap de habitacion actual
;; a habitacion nueva
;; REGISTROS DESTRUIDOS: -
;; ENTRADA: 
;;          HL -> Puntero a habitacion nueva
;; SALIDA:  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
set_current_room:
    ld  (current_room), hl
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Resetea la cantidad de enemigos activados del 
;; sistema de entidades. Utilizado cuando el enemigo
;; muere.
;; REGISTROS DESTRUIDOS: A, HL
;; ENTRADA: 
;; SALIDA:  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
enemy_reset:
    ld      a, #0
    ld  (m_num_enemies), a
    ld      hl, #enemy_vector
    ld  (m_next_enemy), hl 
    ret 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Registra una nueva entidad añadiendo 1 al contador y añadiendo bullet_size a m_next_enemy para que 
;; apunte a la siguiente entidad que crearemos y devuelve en hl la entidad creada. Si esta lleno, 
;; no modifica m_num_enemies o m_next_enemy y devuelve en hl el puntero a la ultima entidad
;; REGISTROS DESTRUIDOS: AF, BC, HL
;; ENTRADA: -
;; SALIDA:  HL -> Puntero 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
enemy_new:
    ld      a, (m_num_enemies)
    ld      hl, (m_next_enemy)  ;; Cargamos puntero de la nueva entidad
    ld      bc, #enemies_size   ;; Cargamos tamaño de la entidad
    cp      #max_num_enemies    ;; Si a == max_num_enemies (10) no metemos nueva entidad
    jr      z, subtract         ;; Si a-max = 0, no metemos nueva entidad y saltamos para restar a hl

    ;; Caso en el que hay más espacio para entidades
    inc     a
    ld  (m_num_enemies), a      ;; Incrementamos contador en 1 y lo guardamos
    
    add     hl, bc              ;; HL = HL + enemies_size
    ld  (m_next_enemy), hl      ;; El nuevo m_next_enemy es m_next_enemy + tamaño de un enemigo

    subtract:                   ;; Cuando esta lleno, m_next_enemy apunta a la siguiente zona de memoria que no controla este sistema de entidades, 
                                ;; sólo restamos hl para devolver el puntero a la ultima entidad. Si llegamos a añadir entidad, también restamos.
    or      a                   ;; Reset del carry Flag a 0 para asegurarnos de decrementar sin carry (En este caso creo que nunca pasa)
    sbc     hl, bc              ;; Dejamos en hl, el puntero a la entidad que acabamos de crear o la última entidad si esta lleno

    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Copia los primeros enemies_size bytes de hl a de
;; REGISTROS DESTRUIDOS: BC, DE, HL
;; ENTRADA: 
;;          HL -> Origen    DE -> Destino
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
enemy_copy:     
    ld bc, #enemies_size
    ldir
    ret


;; TODO: ir alternando la ejecucion de enemigos
;; unavariable: .db #1
;; code snippet para realizar por ejemplo una ejecucion solo para los enemigos pares y despues los impares y viceversa
;; ld       a, (unavariable)
;; xor #1
;; ld (unavariable), a
;; jr nz, continue

;;      call z, cpct_akp_musicPlay_asm
;;      ld  a, #1
;;      ld (unavariable), a

;; continue:


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Realiza para todas las entidades de nuestra estructura
;; la función pasada por hl
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX
;; Nota:    call puede destruir registros dependiendo de HL
;; Funciones que podemos pasar:
;;          - ent_clear
;;          - ent_update
;;          - ent_draw
;;          - ent_check_colision_player_enemy
;; Hay que asegurarse que ent_clear, ent_update y ent_draw
;; nunca puedan devolver Z activado
;; ENTRADA: 
;;          HL -> Puntero a funcion
;;          BC -> Por si utilizamos la funcion ent_check_colision_player_enemy
;; SALIDA:  
;;          Flag Z -> Si esta a 1 significa que ha colisionado si hemos puesto en
;;          HL una funcion que detecta colision
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
enemy_doThisForAll:
    ld      a, (m_num_enemies)  ;; Cargamos número de entidades
    inc     a                   ;; Incrementamos inicialmente por si es 0
    dec     a                   ;; para que al restar no realize nada
    jr      z, modifyZ          ;; Cuando hay 0 entidades no hacemos nada
    ld ix, #enemy_vector        ;; Cargamos primera entidad
    ld (metodo), hl             ;; Metemos en el call la direccion de la rutina
    buc:
        ld      d, de_x(ix)
        inc     d
        dec     d               ;; Si X de algun enemigo esta a 0 no lo procesaremos
        
        push    bc
	    push    af              ;; Guardamos en stack el contador
        push    ix              ;; Guardamos en stack la posicion del vector de enemigos
        jr      z, skipProcessing
        metodo = . +1           ;; . es la memoria en la que se encuentra actualmente
                                ;; el +1 es para saltarse el byte de call
        call    #0x00           ;; Pongo 0x00 pero da igual lo que pongamos porque es sustituido por hl
        jr      z, popRegisters ;; si ent_check_colision_player_enemy detecta colision no tenemos porque mirar mas enemigos
skipProcessing:
        pop     ix              
        pop     af                  ;; Pop de la posicion del vector, puntero a nivel y contador
        ld      bc, #enemies_size   ;; Volvemos a cargarlo ya que el call podria cargarse BC
        add     ix, bc              ;; Pasamos a la siguiente entidad
        dec     a                   ;; dec del contador
    	pop     bc
    jr nz, buc                  ;; Si hay mas entidades continuamos, sino acabamos
modifyZ:        ;; Si hay 0 enemigos nos aseguramos de que no colisiona el jugador cambiando el flag Z
    inc     a   ;; Si llamamos a ent_check_colision_player_enemy y llegamos aqui tenemos que asegurarnos de no devolver Z activado
    jr  finish
popRegisters:   ;; la instruccion pop no modifica el flag
    pop     ix
    pop     af
    pop     bc
    xor     a   ;; Dejamos A a 0, y el flag Z a 1, ya que pop af resetea los flags
finish:
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Quita la ultima entidad del array quitando uno del 
;; contador y restando al m_next_enemy el enemies_size
;; Si hay 0 entidades, no hace nada
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX, IY
;; ENTRADA: IX -> Puntero a entidad a dibujar
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
enemy_remove_last:
    ld      a, (m_num_enemies)      ;; Guardamos en a num entidades
    inc     a                       ;; Sumamos uno para que al restar de 0
    dec     a                       ;; Restamos Uno
    jr      z, endRemove            ;; En el caso que quitemos cuando haya cero entidades no hacemos nada
    
    ;; Caso en el que haya uno o más entidades
    dec     a                       
    ld  (m_num_enemies), a          ;; Actualizamos con nuevo valor
    jr      nz, skipRemoveDoors     ;; Si quitamos ultimo enemigo, hay que abrir habitacion
    call    ent_openRoom            ;; Destruye AF, BC, DE, HL, IX, IY
skipRemoveDoors:
    ld      hl, (m_next_enemy)      ;; Cargamos en hl el puntero a donde se crearía una nueva entidad
    ld      bc, #enemies_size       ;; Cargamos lo que vamos a restarle
    or      a                       ;; Nos aseguramos que carry esté a 0 para realizar sbc sin carry
    sbc     hl, bc                  ;; Restamos
    ld  (m_next_enemy), hl          ;; Metemos la nueva posición que sera adonde apuntaba antes - enemies_size

    endRemove:
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Borra el enemigo pasado en ix moviendo los siguientes 
;; enemigos del vector a la posicion ix. Una vez realizado
;; el desplazamiento, elimina el ultimo enemigo y cambia las
;; variables correspondientes.
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX, IY
;; ENTRADA: 
;;          IX -> Puntero a entidad a dibujar
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
enemy_remove_IX:
    ld  (m_aux_enemy), ix       ;; Primero usamos m_aux_enemy para obtener bytes a copiar
  
    ld      hl, (m_aux_enemy)   ;; HL = destino
    ld      bc, #enemies_size
    add     hl, bc              ;; HL = destino + enemies_size = Origen
    ld      de, (m_next_enemy)  ;; DE = posicion de ultimo enemigo/final del vector
    ex      de, hl              ;; DE <> HL
    or      a                   ;; Reset CARRY flag
    sbc     hl, de              ;; HL - DE = Numero de bytes a copiar
    jr      z, itsLast          ;; En este caso es el ultimo enemigo y no tenemos que copiar nada
    ld  (m_aux_enemy), hl 
    ld      bc, (m_aux_enemy)   ;; BC = los bytes que vamos a copiar
    
    ld  (m_aux_enemy), ix       ;; m_aux_enemy = Destino
    ld      de, #enemies_size   ;; 
    ld      hl, (m_aux_enemy)   ;; HL = Destino
    add     hl, de              ;; HL = Origen
    ld      de, (m_aux_enemy)   ;; DE = destino
    ldir    ;; Copiamos del Origen al destino BC bytes
itsLast:
    call enemy_remove_last  ;; Destruye AF, BC, DE, HL, IX, IY. Una vez movido los enemigos quitamos ultimo
    ret 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Dibuja una entidad
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL
;; ENTRADA: 
;;          IX -> Puntero a entidad a dibujar
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_draw: ;; TODO: Modificar para que funcione bien la transparencia al dibujar el sprite
    ld      a, #1           ;; 1 = Dibujar back_buffer
    call      ren_drawEntity  ;; Destruye AF, BC, DE, HL
    xor     a
    inc     a   ;; Para asegurarnos que no devuelva flag Zero activado
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Redibuja parte del nivel que destruye el jugador 
;; la moverse. Pensado para sprites de 16*16
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX, IY
;; ENTRADA: 
;;          IX -> Puntero a drawable entity con sprite
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_clear:
    ld      bc, #0x0403     ;; b (altura) = 4 y c (anchura) = 3
    ld      de, #_rooms1_W  ;;
    call ren_setDrawMap     ;; Destruye AF, DE, HL

    ld      a, de_x(ix)     ;; A = X
    sub     #4              ;; Le restamos 4 para obtener un tile a la derecha
    ld      c, a            ;; C = X - 4(bytes) // C = X - 16(pixeles)

    ld      a, de_y(ix)
    sub     #8              ;; A = Y - 8
    
    ;; ren_getLevelPos devuelve
    ;; HL-> Puntero al tile donde se encuentra la X e Y pasada
    ;; D -> 0 Cuando no esta alineado, 1 cuando lo esta (En eje Y)
    ;; E -> 0 Cuando no esta alineado, 1 cuando lo esta (En eje X)
    ;; A -> offset en positivo de Y
    ;; B -> offset en positivo de X
    ld      hl, (current_room)  ;; HL = Puntero a habitacion
    call ren_getLevelPos    ;; Destruye AF, BC, DE, HL
    ld      d, a            ;; D = offset Y
    ld      a, de_x(ix)     ;; A = X
    sub     #4              ;; quitamos para el tile que hemos mirado, a la izquierda
    sub     b               ;; quitamos offset para estar alineado, si ya lo esta es 0
    ld      c, a            ;; C = Posicion de X del tile alineado

    ld      a, de_y(ix)     ;; A = Y
    sub     #8              ;; quitamos para el tile que hemos mirado, arriba
    sub     d               ;; quitamos offset para estar alineado, si ya lo esta es 0
    ld      b, a            ;; B = Posicion Y del tile alineado

    ex      de, hl          ;; DE = HL( puntero al tilemap)    
    push    de              ;; Lo guardamos porque getScreenPtr se lo carga
    
    ld      de, #0xC000         ;; Comienzo memoria de video
    call cpct_getScreenPtr_asm  ;; Destruye AF, BC, DE, HL. Devuelve en HL puntero a memvid  

    pop     de              ;; Restauramos puntero al mapa

    push    de 
    push    hl              ;; Pusheamos ya que quizas hacemos clear en el back_buffer

    ld      c, #0           ;; Para dibujar en front_buffer
    push    ix
    call    ren_drawMap     ;; Destruye AF, BC, DE, HL, IX, IY
    pop     ix

    pop     hl
    pop     de
    ld      a, e_he(ix)
    inc     a
    dec     a               ;; Para comprobar si el valor actual es positivo.
    jp      p, skipFullClear
    ;; Si la vida es 0, realizamos un clear en los dos buffers
    ld      c, #1
    call    ren_drawMap
skipFullClear:

    xor     a
    inc     a   ;; Para asegurarnos que no devuelva flag Zero activado
    ret 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Llama a la funcion almacenada en _upd
;; REGISTROS DESTRUIDOS:    HL (OJO: las funciones 
;; que llama si que destruyen registros)
;; ENTRADA:     -
;; SALIDA:      -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_update:
   ld     h, e_up_h(ix)    
   ld     l, e_up_l(ix)     ;; cargamos _upd en hl
   jp    (hl)               ;; llama a hl y hacer ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Mueve la entidad pasada por ix
;; REGISTROS DESTRUIDOS:    AF
;; ENTRADA: 
;;          IX -> Puntero a entidad
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_move:
   ld    a, de_x(ix)    
   add   e_vx(ix)
   ld    de_x(ix), a  ;; Actualizamos nuevo valor
                      ;; de_x = de_x + e_vx
   ld    a, de_y(ix) 
   add   e_vy(ix)
   ld    de_y(ix), a  ;; Actualizamos nuevo valor
                      ;; de_y = de_y + e_vy
   ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Mueve la bala
;; REGISTROS DESTRUIDOS:    AF, BC, DE, HL
;; ENTRADA: 
;;          IX -> Puntero a entidad
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_move_bullet:
    ld      a, de_x(ix)     ;; Para no realizarlo cuando esta creado de manera default
    inc     a 
    dec     a
    jr      z, acabado      ;; Si x es 0, no realizar nada

    add     es_vx(ix)       ;; X = X + VX
    ld      c, a            ;; C = X ( desplazado )

    ld      a, de_y(ix)     ;; A = Y
    add     es_vy(ix)       ;; A = Y + VY

    ld      hl, (current_room)  ;; HL = Puntero a habitacion
    call ren_getLevelPos    ;; Destruye AF, BC, DE, HL
    ld      a, (hl)         ;; para mirar el valor del tile
    sub     #16             ;; Restamos 16 para que a partir del tile 16 de como colision
    jp      p, recorridoTodo      ;; Si ocurre colision en primer tile que miramos, dejamos de mirar

    ld      a, de_x(ix)
    add     #-1
    jp      m, recorridoTodo        ;; Checkeo de colision por la izquierda

    ld      a, de_x(ix)
    add     #54
    jp      m, recorridoTodo        ;; Checkeo de colision por la derecha

    ld      a, de_y(ix)
    cp      #10
    jp      z, recorridoTodo        ;; Checkeo de colision arriba

    ld      a, de_y(ix)
    cp      #150
    jp      z, recorridoTodo        ;; Checkeo de colision arriba

    ld      a, es_distance(ix) ;; La distancia, se ira restando de uno en uno tanto en X como en Y
    dec     a
    jr      z, recorridoTodo

    ld es_distance(ix), a   ;; Actualizamos distancia

    ;; Modificamos x e y, no podemos llamar a ent_move ya que tiene sprite y los offset serian incorrectos
    ld    a, de_x(ix)    
    add   es_vx(ix)
    ld    de_x(ix), a  ;; Actualizamos nuevo valor
                        ;; de_x = de_x + e_vx
    ld    a, de_y(ix) 
    add   es_vy(ix)
    ld    de_y(ix), a  ;; Actualizamos nuevo valor
                        ;; de_y = de_y + e_vy
    jr      acabado
    recorridoTodo: ;; Acaba recorrido
    push    ix
    call    ent_clear
    call    player_reset_bullet ;; Destruye IX. Cuando colisiona ponemos x de bala a 0
    pop     ix

    acabado: 
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Dibuja la bala
;; REGISTROS DESTRUIDOS:    AF, BC, DE, HL
;; ENTRADA: 
;;          IX -> Puntero a entidad
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_draw_bullet:
    jp      ren_drawBullet  ;; Destruye AF, BC, DE, HL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Mueve al enemigo
;; REGISTROS DESTRUIDOS:    AF, BC, DE, HL
;; ENTRADA: 
;;          IX -> Puntero a entidad
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_enemy1_move:

    ;; Codigo para ralentizar el enemigo
    ld      a, (var_enemy_delay_counter)
    dec     a
    ld  (var_enemy_delay_counter), a        ;; Guardamos en el contador el valor actual
    
    jp      nz, delay           ;;  No realizamos nada si es mayor que 0

    ld      a, (var_enemy_delay)      ;; Reset del contador del delay
    ld  (var_enemy_delay_counter), a


;;    jp      noSeMueve     ;; Utilizado para pruebas
    ld      b, de_y(ix)     ;; B = Y_enemigo
    push    ix
    ld      ix, #hero_data
    ld      a, de_y(ix)     ;; A = Y_jugador
    pop     ix

    sub     b                   ;; Y_jugador - Y_enemigo
    jp      m, enemigo_abajo    ;; Si Y_enemigo > Y_jugador, saltamos a estado_1: abajo
	cp      #0                  ;; Si coincide en Y, miramos si tiene que seguir al jugador por la izquierda o derecha
	jp      z, estudio_x        ;; estado dos se refiere a: derecha o izquierda
    jr      enemigo_arriba      ;; Y_jugador > Y_enemigo, saltamos a estado_3: arriba

enemigo_abajo:                  ;; Intentamos desplazar al enemigo arriba
    ld      a, #3
    ld      bc, #0x00FE             ;; B = lo que sumamos a X, C = lo que sumamos a Y
    ld      de, #0x0001             ;; Miraremos un tile a la derecha cuando no este alineado
    call    ent_check_collision     ;; Devuelve en Flag Z si colisiona o no
    jr      z, estudio_x            ;; Si da 0, es que colisionamos y miramos si podemos desplazarnos en X
    ;; Si no colisionamos Modificamos velocidad, sprite con direccion correcta y salimos
    ld      hl, #_movingEnemy1_sp_3     
    ld      de_sp_l(ix) , l
    ld      de_sp_h(ix) , h
    ld      e_vy(ix), #-2
    jp      moverEnemigo
enemigo_arriba:
    ld      a, #3
    ld      bc, #0x0010         ;; B = lo que sumamos a X, C = lo que sumamos a Y
    ld      de, #0x0001         ;; Miraremos un tile a la derecha cuando no este alineado
    call    ent_check_collision ;; Devuelve en Flag Z si colisiona o no
    jr      z, estudio_x            ;; Si da 0, es que colisionamos y miramos si podemos desplazarnos en X
    ;; Si no colisionamos Modificamos velocidad y salimos
    ld      hl, #_movingEnemy1_sp_0     
    ld      de_sp_l(ix) , l
    ld      de_sp_h(ix) , h
    ld      e_vy(ix), #2
    jp      moverEnemigo

estudio_x:
    ld      b, de_x(ix)     ;; B = X_enemigo
    push    ix
    ld      ix, #hero_data
    ld      a, de_x(ix)     ;; A = X_jugador
    pop     ix

    sub     b                   ;; X_jugador - X_enemigo
    jp      m, enemigo_derecha  ;; Si X_enemigo > X_jugador, saltamos a estado_1: derecha
	cp      #0                  ;; Si coincide en Y, miramos si tiene que seguir al jugador por la izquierda o derecha
	jp      z, noSeMueve        ;; Si ha llegado aqui, X e Y del jugador son iguales
    jp      enemigo_izquierda      ;; Y_jugador > Y_enemigo, saltamos a estado_3: izquierda

enemigo_derecha:                ;; en este caso el enemigo esta a la derecha del jugador y tiene que moverse a la izquierda
    ld      a, #3
    ld      bc, #0xFF00             ;; B = lo que sumamos a X, C = lo que sumamos a Y
    ld      de, #_rooms1_W          ;; Miraremos colision en tiles de abajo
    set     7, d                    ;; Para indicar que es checkeo en horizontal
    call    ent_check_collision     ;; Devuelve en Flag Z si colisiona o no
    jr      z, noSeMueve            ;; Si da 0, es que colisionamos y no nos movemos
    ld      hl, #_movingEnemy1_sp_2 ;; se podria cambiar para flipear sprite
    ld      de_sp_l(ix) , l
    ld      de_sp_h(ix) , h
    ld      e_vx(ix), #-1
    jp      moverEnemigo

enemigo_izquierda:              ;; en este caso el enemigo esta a la izquierda del jugador y tiene que moverse a la derecha
    ld      a, #3
    ld      bc, #0x0400             ;; B = lo que sumamos a X, C = lo que sumamos a Y
    ld      de, #_rooms1_W          ;; Miraremos colision en tiles de abajo
    set     7, d                    ;; Para indicar que es checkeo en horizontal
    call    ent_check_collision     ;; Devuelve en Flag Z si colisiona o no
    jr      z, noSeMueve            ;; Si da 0, es que colisionamos y no nos movemos
    ld      hl, #_movingEnemy1_sp_1
    ld      de_sp_l(ix) , l
    ld      de_sp_h(ix) , h
    ld      e_vx(ix), #1
    
moverEnemigo:
    ;; Checkeo colision entre enemigos o con jugador
    ld      a, de_x(ix)
    add     e_vx(ix)
    ld      b, a            ;; B = nueva posicion de x a la que se va a desplazar
    ld      a, de_y(ix)
    add     e_vy(ix)
    ld      c, a            ;; C = nueva posicion de y a la que se va a desplazar
    ld      a, #0       ;; Ponemos a 0 para indicar que comprobamos colision de enemigo con jugador y otros enemigos
    push    ix
    call    ent_check_collision_entities
    pop     ix
    dec     a                     ;; Si A = 1, colisiona y no modificamos segun velocidad calculada
    jr      z, noSeMueve          
    ;; Si no colisiona, movemos segun modificacion de velocidad

    call  ent_move ;; Destruye AF. Actualiza posicion segun velocidad modificada por IA enemigo
noSeMueve:
    ;; Reseteamos las velocidades
    ld e_vx(ix), #0
    ld e_vy(ix), #0
delay:
    xor     a
    inc     a   ;; Para asegurarnos que no devuelva flag Zero activado
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Rutina que devuelve si ha ocurrido colision. Con 
;; A escogemos si queremos estudiar el jugador o 
;; el enemigo.
;; REGISTROS DESTRUIDOS:   AF, BC, DE, HL, IX, IY
;; ENTRADA: 
;;          A   -> Indica si la entidad que se mueve es un enemigo o jugador
;;              (1): Se mueve el jugador
;;              (0): Se mueve un enemigo
;;          B   -> Nueva posicion de X de la entidad que intenta moverse
;;          C   -> Nueva posicion de Y de la entidad que intenta moverse
;;          IX  -> Enemigo o jugador con el que estudiamos colision
;; SALIDA:  
;;          A   -> Si esta a 1, colision
;;              -> Si esta a 0, no colision     
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_check_collision_entities:
    dec     a
    jr      nz, modifyForEnemy      ;; Si a no es 0 cuando decrementamos, lo tratamos como enemigo

    ld      hl, #ent_check_colision_player_enemy        
    call    enemy_doThisForAll
    jr      nz, collision_not_happen
    xor     a
    inc     a
    ret     ;; Devolvera en flag Z si ha colisionado o no
    
modifyForEnemy:
    ;; Primero miramos si colisiona el enemigo con el jugador
    push    ix
    push    bc 
    ld      ix, #hero_data                  ;; pasamos en ix el jugador en vez del enemigo
    call    ent_check_colision_player_enemy
    pop     bc
    pop     ix                              ;; pop no modifica los flags
    jr      nz, checkCollisionEnemies
    ;;      Si entra aquí, ha colisionado, resta 1 vida al jugador y sale

    call    player_remove_health    ;; Destruye AF, BC, DE, HL, IX, IY
    xor     a
    inc     a                       ;; Enemigo colisiona con jugador, decrementamos vida y devolvemos uno en A
    ret 

;; Si no ha colisionado con el jugador, miraremos colision entre enemigos y en este caso no quitaremos vida
checkCollisionEnemies:
    ld      d, de_x(ix)
    ld      e, de_y(ix)         ;; DE = X e Y del enemigo original

    ld  de_x(ix), #0
    ld  de_y(ix), #0            ;; Lo ponemos a 0 para evitar que colisione consigo mismo

    ld      hl, #ent_check_colision_player_enemy   
    push    de   
    push    ix  
    call    enemy_doThisForAll                      ;; Lo hacemos para todos los enemigos uno de ellos siendo el jugador
    pop     ix
    pop     de
    ld  de_x(ix), d
    ld  de_y(ix), e                                 ;; Ponemos la X e Y original del enemigo

    jr      nz, collision_not_happen       ;; Una vez restauramos las posiciones iniciales saltamos si no hay colision
    ;;      Si entra aquí, ha colisionado y sale
    xor     a
    inc     a                       ;; Enemigo colisiona con jugador, decrementamos vida y devolvemos uno en A
    ret
collision_not_happen:
    xor     a   ;; A = 0
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Mira si existe la colision entre jugador y enemigo
;; y si existe colision devuelve resultado en flag Z.
;; REGISTROS DESTRUIDOS:   AF, BC
;; ENTRADA: 
;;          IX  -> Puntero a entidad
;;          B   -> Posicion X nueva de otra entidad
;;          C   -> Posicion Y nueva de otra entidad
;; SALIDA:  
;;          Flag Z -> Si esta a 1, colision
;;                 -> Si esta a 0, no colision
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_check_colision_player_enemy:
	ld      a, de_x(ix)
	sub     b
	jp      m, al_reves_x       ;; Si X_enemigo < X_jugador, miramos otro caso
	sub     #4
	jp      m, colisiona_y      ;; Colisiona en X, miramos en Y
	jr      no_colisiona     
	al_reves_x:
		ld      a, b
		sub     de_x(ix)
		sub     #4
		jp      m, colisiona_y  ;; Colisiona en X, miramos en Y
		jr      no_colisiona
	colisiona_y:
		ld      a, de_y(ix)
		sub     c
		jp      m, al_reves_y   ;; Si Y_enemigo < Y_jugador, miramos otro caso
		sub     #16
		jp      m, colisiona    ;; Colisiona en X y en Y
		jr      no_colisiona
	al_reves_y:
		ld      a, c
		sub     de_y(ix)
		sub     #16
		jp      m, colisiona    ;; Colisiona en X y en Y
		jr      no_colisiona
	colisiona:     
		;;call    player_remove_health ;; Dejamos que esta llamada la haga el jugador o enemigo cuando detecte la colision
        xor     a           ;; Deja flag Z a 1 y A = 0
        jr      endRoutine
    no_colisiona:
        xor     a           ;; ld   a, #0
        inc     a           ;; Deja flag Z a 0 y A = 1
    endRoutine:
		ret	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Mira si existe la colision entre bala y enemigo
;; y si existe colision decrementa la vida del enemigo y
;; si su vida llega a 0, realiza clear en enemigo en
;; los dos buferes y lo quita del sistema de entidades
;; REGISTROS DESTRUIDOS:   AF, BC, DE, HL, IX, IY
;; ENTRADA: 
;;          IX  -> Puntero a enemigo
;;          B   -> Posicion X bala
;;          C   -> Posicion Y bala
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_check_colision_bullet_enemy: ;; COPY-PASTE DE ent_check_colision_player_enemy
    ld      a, de_x(ix)
	sub     b
	jp      m, al_reves_xB      ;; Si X_enemigo < X_bala, miramos otro caso
	sub     #1
	jp      m, colisiona_yB     ;; Colisiona en X, miramos en Y
	ret     ;; No colisiona
	al_reves_xB:
		ld      a, b
		sub     de_x(ix)
		sub     #4
		jp      m, colisiona_yB ;; Colisiona en X, miramos en Y
		ret     ;; No colisiona
	colisiona_yB:
		ld      a, de_y(ix)
		sub     c
		jp      m, al_reves_yB  ;; Si Y_enemigo < Y_bala, miramos otro caso
		sub     #1
		jp      m, colisionaB   ;; Colisiona en X y en Y
		ret     ;; No colisiona
	al_reves_yB:
		ld      a, c
		sub     de_y(ix)
		sub     #16
		jp      m, colisionaB   ;; Colisiona en X y en Y
		ret     ;; No colisiona
	colisionaB:
    ;; Colisiona bala con enemigo
        push    ix 
        call    player_reset_bullet ;; Destruye IX. Cuando colisiona ponemos x de bala a 0
        call    player_get_dmg      ;; Destruye IX. Devuelve en B el daño del jugador
        pop     ix                  ;; Mantenemos ix
        
        ld      a, e_he(ix)         ;; A = Vida enemigo
        sub     b
        ld  e_he(ix), a             ;; Vida enemigo = Vida enemigo - Daño del jugador
        jp      m, destroyEnemy     ;; Si la vida es negativo realizamos clear de los dos buffers y lo quitamos del vector
        ret     ;; Si la vida no es zero, salimos ( no ha muerto enemigo)

destroyEnemy:
        push    ix 
        call    ent_clear           ;; Destruye AF, BC, DE, HL, IX, IY. Para hacer clear en dos buffers
        pop     ix                  ;; Restauramos IX
		call    enemy_remove_IX     ;; Destruye AF, BC, DE, HL, IX, IY. Quitamos enemigo del vector de enemigos

    ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Realizamos el salto apropiado dependiendo del tile que estamos mirando
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL
;; ENTRADA: 
;;          HL  -> Puntero al tile que estudiamos
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
ent_cmp_tiles:
    ld      a, (hl)         ;; Cargamos en A valor del tile
    sub     #16             ;; Restamos 16 para que a partir del tile 16 de como colision
    jp      p, colissionHappen      ;; Si ocurre colision en primer tile que miramos, dejamos de mirar

    ld      a, (hl)
    cp      #tile_vida
    jr      z, pickupHealth

    cp      #tile_key
    jr      z, pickupKey

    cp      #tile_stairs1
    jr      z, downStairs

    cp      #tile_stairs2
    jr      z, downStairs

    cp      #tile_metralleta
    jr      z, pickupMachineGun

    cp      #tile_santa1
    jr      z, santa_Victory

    cp      #tile_santa2
    jr      z, santa_Victory

    cp      #tile_santa3
    jr      z, santa_Victory

    jumpPos = . + 1
    jp      continueCol1    ;; Cambiamos esta posicion mediante HL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Estudia colision de entidad pasada en IX en una direccion
;; En BC pasamos la distancia con la que queremos probar si 
;; ha colisionado. Y en DE la distancia que tiene que recorrer
;; si tiene que estudiar más de un tile. 
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL
;; ENTRADA: 
;;          IX -> Entidad con la que queremos mirar colision
;;          BC -> B lo que sumamos a X, C lo que sumamos a Y
;;          DE -> Offset que usaremos para desplazar el puntero del tilemap
;;          Si el bit 7 de D esta a 1, sabemos que es colision horizontal
;; SALIDA:  
;;          F (ZERO) -> 1 Colision, 0 No Colision
;;          A        -> Si no ha colisionado, 
;;          Devolvemos en A, el tile con el que ha colisionado
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_check_collision:
    ld      a, de_x(ix)
    add     a, b                
    ld      b, c                ;; B = Offset pasado en C
    ld      c, a                ;; C = X + Offset pasado en B

    ld      a, de_y(ix)
    add     a, b                ;; A = Y + Offset pasado en C que hemos guardado en B

    push    de                  ;; Guardamos de ya que ren_getLevelPos se lo carga
    ld      hl, (current_room)  ;; HL = Puntero a habitacion en la que se encuentra
    call    ren_getLevelPos     ;; Destruye AF, BC, DE, HL. Obtenemos Tile al que nos vamos a mover del jugador

    ;; Estas instrucciones no modifican el flag Z
    ld      b, d            ;; B = Alineacion en Y
    ld      c, e            ;; C = Alineacion en X    
    pop     de              ;; Restauramos "desplazador"

    push    hl
    ld      hl, #continueCol1
    ld (jumpPos), hl
    pop     hl

    jp      ent_cmp_tiles
continueCol1:

    bit     7, d                ;; Si esta puesto a 1, significa que alineacion en X da igual
    res     7, d                ;; Reseteamos el bit para el desplazamiento de hl
    jr      nz, notCheckX       ;; Si no esta a 0 sabemos que es desplazamiento horizontal
    dec     c                   ;; Miramos alineacion en x
    jr      nz, mirarColisionExtra ;; Desplazamiento vertical y no alineado en x = mirar otro tile
    jr      noMiraTercerTile    ;; Si es 0, no miramos mas tiles
notCheckX:

    add     hl, de              ;; hl + desplazamiento
    
    push    hl
    ld      hl, #continueCol2
    ld (jumpPos), hl
    pop     hl

    jp      ent_cmp_tiles
continueCol2:
    

    dec     b   
    jr      z, noMiraTercerTile ;; Si esta alineado en Y, no mirar tercer tile

mirarColisionExtra:

    add     hl, de              ;; hl + desplazamiento

    push    hl
    ld      hl, #continueCol3
    ld (jumpPos), hl
    pop     hl

    jp      ent_cmp_tiles
continueCol3:
    
noMiraTercerTile: ;; Si salta aqui es porque no ha colisionado
    ld      a, #0
    dec     a       ;; En este caso queremos devolver flag Z a 0
    ret
pickupHealth:    ;; Si salta aqui entonces ha colisionado y flag Z estará activado
    call    player_get_health   ;; Devuelve en B las vidas del jugador
    ld      a, #10              ;; Numero máximo de vidas
    cp      b
    jr      z, skipDeleteTile
    ld  (hl), #tile_fondo
skipDeleteTile:
    ld      a, #0
    inc     a    ;; A = 1
    ret
    
pickupKey:
    ld      a, #1
    inc     a    ;; A = 2
    ld  (hl), #tile_fondo
    ret
downStairs:
    ld      a, #2
    inc     a   ;; A = 3
    ret
pickupMachineGun:
    ld      a, #3
    inc     a   ;; A = 4
    ld  (hl), #tile_fondo
    ret
santa_Victory:
    ld      a, #4
    inc     a   ;; A = 5
    ret
colissionHappen:
    xor     a           ;; Flag Z activado y A = 0
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Se encarga de crear los enemigos segun el tile 
;; pasado en DE cambiando enemy_creator y 
;; despues usando enemy_creator para meterlo en 
;; el sistema de entidades.
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX
;; ENTRADA: 
;;          D  -> Valor del tile X
;;          E  -> Valor del tile Y
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
set_enemy:
    ;; Calculo de posicion x de enemigo segun tile en el que nos encontramos
    ld      ix, #enemy_creator  ;; enemy_creator lo modificamos para crear el enemigo en la posicion correcta

    ld      a, #20          ;; A = 20
    sub     d               ;; A = 20 - D = desplazamiento en X/ numero de veces que vamos a sumarle 4 a 0
    ld      b, a            ;; B = A

    ld      a, #0          ;; A = 0
    inc     b 
    dec     b 
    jr      z, skipSumX      ;; Si B es 0 entonces X es 0

keepSumX:
    add     #4              ;; A = A + 4
    dec     b               ;; Decrementamos el desplazamiento en X
    jr      nz, keepSumX     ;; Sumamos desplazamiento en X * 4 bytes (cada tile)

skipSumX:
    ;; Si B es 0 entonces guardamos 0
    ld  de_x(ix), a         ;; X_enemigo = A

    ld      a, #21          ;; A = 21
    sub     e               ;; A = 20 - D = desplazamiento en X/ numero de veces que vamos a sumarle 4 a 0
    ld      b, a            ;; B = A

    ld      a, #0           ;; A = 0. No nos saltamos el viewport. Empezamos en 0
    inc     b 
    dec     b 
    jr      z, skipSumY      ;; Si B es 0 entonces X es 0

keepSumY:
    add     #8              ;; A = A + 4
    dec     b               ;; Decrementamos el desplazamiento en X
    jr      nz, keepSumY     ;; Sumamos desplazamiento en X * 4 bytes (cada tile)

skipSumY:
    ;; Si B es 0 entonces guardamos 0
    ld  de_y(ix), a         ;; Y_enemigo = A

    call    enemy_new           ;; Destruye AF, BC, HL. Devuelve en HL el puntero a la entidad creada
    ex      de, hl              ;; lo guardamos en DE que es el destino de ent_copy
    ld      hl, #enemy_creator  ;; Guardamos en HL el puntero al enemigo
    call    enemy_copy          ;; Destruye BC, DE, HL. Guarda en DE, el contenido de HL

    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Segun la habitacion en la que nos encontremos, 
;; cargara enemigos en la posicion donde se encuentre 
;; el tile de enemigo, reemplazandolo con el tile de fondo
;; REGISTROS DESTRUIDOS: AF, BC, DE, IX
;; ENTRADA: 
;;          D  -> Valor del tile X
;;          E  -> Valor del tile Y
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_loadEnemiesRoom:
    push    hl              ;; Guardado inicial de puntero a habitacion
 
    ld      e, #21 ;; E = Numero de tiles que miraremos en alto (nos saltamos el viewport)
    
    
resetWidth:
    ld      d, #20 ;; D = Numero de tiles que miraremos en ancho
continueWidth:
    
    ;; Segun los valores del tile en el que nos encontramos en D y E
    ;; Crea un enemigo con la posicion x e Y correspondiente al tile
    
    ld      a, (hl)         ;; S
    cp      #tile_enemy    
    jr      nz, skipChange  ;; Si en tile que miramos hay enemigo, 
    ld      (hl), #tile_fondo        ;; metemos tile de fondo al spawnear los enemigos
    push    hl
    push    de              ;; Queremos mantener DE y HL
    call    set_enemy       ;; Destruye AF, BC, DE, HL, IX
    pop     de
    pop     hl

skipChange:
    inc     hl
    dec     d
    jr      z, subHeight
    jr      continueWidth
subHeight:
    ld      bc, #-20
    add     hl, bc      ;; HL = Primer tile en X

    ld      bc, #_rooms1_W
    add     hl, bc      ;; HL = Un tile abajo

    dec     e
    jr      nz, resetWidth
 
    ;; Cosa que hacemos si encontramos en el tile
 
    pop     hl          ;; Devolucion del hl original
    ret

;;  Entrada:    A   -> Tile actual. Si es puerta
;;                      lo quitamos
;;              HL  -> Puntero al tile
openRoom_checkTile:
    cp      #tile_puerta1             ;; Si es una puerta
    jr      nz, checkSecondDoorTile
    jr      changeTile
checkSecondDoorTile:
    cp      #tile_puerta2
    jr      nz, skipChangeR
changeTile:
    ld      (hl), #tile_fondo        ;; Si es una puerta metemos tile de fondo
skipChangeR:
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Recorre habitacion de manera circular para mirar 
;; si hay puertas cerradas. Si hay, las cambia por tile
;; de fondo. Se realiza al matar a todos los enemigos
;; en la habitacion.
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX, IY
;; ENTRADA: 
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_openRoom:
    ld      hl, (current_room)        ;; Guardamos la direccion a la habitacion
    ld      bc, #_rooms1_W
;; PRIMERA FILA
    ld      d, #19 ;; D = Numero de tiles que miraremos en ancho
addWidthR1:
    ld      a, (hl)         ;; S
    ;; CHECKEO DE TILE
    call openRoom_checkTile
    inc     hl
    dec     d
    jr      nz, addWidthR1

;; SEGUNDA FILA
ld      hl, (current_room)
add     hl, bc              ;; Miramos Segunda Fila
ld      d, #19 ;; D = Numero de tiles que miraremos en ancho
addWidthR2:
    ld      a, (hl)         ;; S
    ;; CHECKEO DE TILE
    call openRoom_checkTile
    inc     hl
    dec     d
    jr      nz, addWidthR2

;;  HL se queda al final de la segunda fila

;; ULTIMA COLUMNA
    ld      d, #19

addHeightR:
    ld      a, (hl)         ;; S
    ;; CHECKEO DE TILE
    call    openRoom_checkTile
    add     hl, bc 
    dec     d
    jr      nz, addHeightR

;; ULTIMA FILA
    ld      d, #19 ;; D = Numero de tiles que miraremos en ancho
subWidthR1:
    ld      a, (hl)         ;; S
    ;; CHECKEO DE TILE
    call    openRoom_checkTile
    dec     hl
    dec     d
    jr      nz, subWidthR1

    ld      bc, #-_rooms1_W
    add     hl, bc          ;; Vamos a la penultima fila
    ld      de, #19
    add     hl, de          ;; Vamos al final de la penultima fila

;; PENULTIMA FILA
    ld      d, #19 ;; D = Numero de tiles que miraremos en ancho
subWidthR2:
    ld      a, (hl)         ;; S
    ;; CHECKEO DE TILE
    call    openRoom_checkTile
    dec     hl
    dec     d
    jr      nz, subWidthR2


;; ULTIMA COLUMNA
    ld      d, #20
    ld      bc, #-_rooms1_W

subHeightR:
    ld      a, (hl)         ;; S
    ;; CHECKEO DE TILE
    call    openRoom_checkTile
    add     hl, bc 
    dec     d
    jr      nz, subHeightR
    call    player_drawMap  ;; Destruye AF, BC, DE, HL, IX, IY
    ret
