;;This file is part of Elfo saves Christmas.

    ;;Elfo saves Christmas is free software: you can redistribute it and/or modify
    ;;it under the terms of the GNU General Public License as published by
    ;;the Free Software Foundation, either version 3 of the License, or
    ;;(at your option) any later version.

    ;;Elfo saves Christmas is distributed in the hope that it will be useful,
    ;;but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;;GNU General Public License for more details.

    ;;You should have received a copy of the GNU General Public License
    ;;along with Elfo saves Christmas.  If not, see <https://www.gnu.org/licenses/>.
.include "main.h.s"
.include "cpctelera.h.s"
.include "game.h.s"
.include "player.h.s" ;; Incluye render y entity
.include "pack/level1_pack.h.s"
.include "pack/level2_pack.h.s"
.include "pack/level3_pack.h.s"
.include "pack/level4_pack.h.s"
.include "pack/level5_pack.h.s"
.include "pack/level6_pack.h.s"
.include "pack/level7_pack.h.s"
.include "pack/level8_pack.h.s"
.include "pack/level9_pack.h.s"
.include "pack/level10_pack.h.s"


;; Decompress_buffer siempre tiene que ser donde acabe la musica
decompress_buffer       = 0x04A1
levelMaxSize1           = #_level1_pack_size    
decompress_buffer_end1  = decompress_buffer + levelMaxSize1 - 1

levelMaxSize2           = #_level2_pack_size    
decompress_buffer_end2  = decompress_buffer + levelMaxSize2 - 1

levelMaxSize3           = #_level3_pack_size    
decompress_buffer_end3  = decompress_buffer + levelMaxSize3 - 1

levelMaxSize4           = #_level4_pack_size    
decompress_buffer_end4  = decompress_buffer + levelMaxSize4 - 1

levelMaxSize5           = #_level5_pack_size    
decompress_buffer_end5  = decompress_buffer + levelMaxSize5 - 1

levelMaxSize6           = #_level6_pack_size    
decompress_buffer_end6  = decompress_buffer + levelMaxSize6 - 1

levelMaxSize7           = #_level7_pack_size    
decompress_buffer_end7  = decompress_buffer + levelMaxSize7 - 1

levelMaxSize8           = #_level8_pack_size    
decompress_buffer_end8  = decompress_buffer + levelMaxSize8 - 1

levelMaxSize9           = #_level9_pack_size    
decompress_buffer_end9  = decompress_buffer + levelMaxSize9 - 1

levelMaxSize10           = #_level10_pack_size    
decompress_buffer_end10  = decompress_buffer + levelMaxSize10 - 1

;; Inicialmente es 1
currentLevelNum:    .db #1

victoryPlayer:      .db #0

gameOver_victoryPos = #0xC1EC

tecla_restart   =   #Key_Esc
tecla_exit      =   #Key_0


game_start:

resetAfterDeath:
    call    enemy_creator_reset
    call    player_reset            ;; Establecemos los parametros por defecto del jugador
    call    enemy_reset             ;; Dejamos el vector de enemigos vacio
    ld      a, #1
    ld  (#currentLevelNum), a       ;; Volvemos al nivel 1
    call game_setCurrentLevel       ;; Destruye AF, BC, DE, HL
    ld      b, #3                   ;; Tenemos que pasar el numero inicial de vidas
    call player_setInitialViewport  ;; Destruye AF, BC, DE, HL, IX, IY. Carga el viewport inicial del jugador
    call player_drawMap             ;; Destruye AF, BC, DE, HL, IX, IY. Dibuja mapa en la habitación en la que se encuentra el jugador

loop:
    ;;          Clear , update y Draw de hero
    ld      ix, #hero_data
    call    ent_clear          ;; Destruye AF, BC, DE, HL, IX, IY
    ld      ix, #hero_data
    call    ent_update         ;; llama a _upd de #hero_data
    
    ;;          Clear , update y Draw de bala ( se puede hacer en player )
    call    player_clear_bullet
    call    player_update_bullet
  
    ;;          Clear, update y draw de vector de enemigos
    ld  hl, #ent_clear          ;; Destruye AF, BC, DE, HL, IX, IY
    call enemy_doThisForAll

    ld  hl, #ent_update         ;; llama a _upd de enemies
    call enemy_doThisForAll

    ;; Una vez realizamos clear de todos los elemento y actualizamos la posicion, dibujamos

    ld      ix, #hero_data
    call    ent_draw           ;; Destruye AF, BC, DE, HL

    call    player_draw_bullet 

    ld  hl, #ent_draw           ;; Destruye AF, BC, DE, HL  
    call enemy_doThisForAll

    
;; Comprobacion muerte de personaje
    ld      ix, #hero_data
    ld      a, e_he(ix)
    cp      #0
    jr      nz, stillAlive      ;; Si la vida llega a 0, 
    push    ix
    ld      de, #_tilemap_game_over
    call    showGameOver_Victory
    pop     ix
    jp      game_start     ;; Redibujamos con todo reseteado
stillAlive:

;;;; Comprobacion victoria de personaje

    ld      a, (#victoryPlayer)
    dec     a
    jr      nz, stillPlaying      ;; Si la vida llega a 0,
    ld      de, #_tilemap_victory
    push    ix 
    call    showGameOver_Victory
    pop     ix
    call    game_resetVictory
    jp      game_start     ;; Redibujamos con todo reseteado
stillPlaying:



;;;;;;;;;;;; CODIGO DE DEBUGEADO PARA ENEMIGOS Y VIDA DEL JUGADOR ;;;;;;;;;;;;;;;;;;;;;;;
;;    ld      ix, #hero_data
;;    ;; CODIGO DE VIDA ;;
;;    ld      a, e_he(ix)
;;    sub     #10             ;; Cambiar por stat de maximo de vida cuando lo tengamos
;;    jr      z, l_no_pulsada ;; no puedo recoger mas vidas. En este caso si tenemos el maximo de vidas no recogemos la vida
;;
;;    ld      hl, #Key_M             ;; Para probar recoger vida. Esto hay que cambiarlo cuando colisione con recogible vida
;;    call    cpct_isKeyPressed_asm  ;; Destruye A, D, BC, HL. Miramos si L esta pulsada
;;    jr      z, l_no_pulsada 
;;    call    player_add_health       ;; Destruye AF, BC, DE, HL, IX, IY
;;    jr      k_no_pulsada            ;; Para no añadir y disminuir vida en mismo ciclo
;;l_no_pulsada:
;;
;;    ld      hl, #Key_N             ;; Para probar recoger vida. Esto hay que cambiarlo cuando colisione con recogible vida
;;    call    cpct_isKeyPressed_asm  ;; Destruye A, D, BC, HL. Miramos si K esta pulsada
;;    jr      z, k_no_pulsada 
;;    call    player_remove_health    ;; Destruye AF, BC, DE, HL, IX, IY
;;k_no_pulsada:
;;    ;; CODIGO DE VIDA ACABADO ;;
;;
;;;;;;;;;;;; FINAL DE CODIGO DE DEBUGEADO;;;;;;;;;;;;;;;;;;;;;;;  

    call ren_newScene           ;; Switch front and back buffers
    call cpct_waitVSYNC_asm
   ;; Loop forever
   jp    loop

;; Dibuja el tilemap de victoria o derrota segun lo que pasemos en DE
showGameOver_Victory:
    push    de 
    ld      c, #_tilemap_game_over_W            ;; Tilemap de game over y victoria son iguales de tamaño
    ld      b, #_tilemap_game_over_H
    ld      de, #_tilemap_game_over_W
    ld      hl, #_tileset_menu_00
    call    cpct_etm_setDrawTilemap4x8_ag_asm   ;; Configuramos Primer Panel

    pop     de                                  ;; DE = tilemap a dibujar
    ld      c, #1                               ;; 1 = back_buffer
    ld      hl, #gameOver_victoryPos
    call    ren_drawMap

waitForESC:
    call  cpct_scanKeyboard_asm 

    ld hl, #tecla_restart
    call cpct_isKeyPressed_asm
    jr    z, waitForESC  

   ret

game_incrementLevel:
    ld      a, (#currentLevelNum)
    inc     a
    ld  (#currentLevelNum), a       ;; Incrementamos
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Descomprime al nivel 1 y configura el puntero
;; de habitacion y tileset
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL
;; ENTRADA: -
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
game_setCurrentLevel:
    ld      a, (#currentLevelNum)           ;; Cargamos nivel actual

    dec     a
    jr      nz, skipLevelOne
    ld      hl, #_level1_pack_end
    ld      de, #decompress_buffer_end1
    jp      decompressAndSet
skipLevelOne:
    dec     a
    jr      nz, skipLevelTwo
    call    enemy_creator_increase_Health
    call    enemy_creator_decrease_Delay
    ld      hl, #_level2_pack_end
    ld      de, #decompress_buffer_end2
    jr      decompressAndSet
skipLevelTwo:
    ;; Aqui meteremos codigo para descomprimir el tercer nivel cuando lo tengamos. Pensar en mejor manera de realizar esto
    dec     a
    jr      nz, skipLevelThree
    call    enemy_creator_decrease_Delay
    ld      hl, #_level3_pack_end
    ld      de, #decompress_buffer_end3
    jr      decompressAndSet
skipLevelThree:
;; Aqui meteremos codigo para descomprimir el tercer nivel cuando lo tengamos. Pensar en mejor manera de realizar esto
    dec     a
    jr      nz, skipLevelFour
    call    enemy_creator_increase_Health
    call    enemy_creator_increase_Health
    ld      hl, #_level4_pack_end
    ld      de, #decompress_buffer_end4
    jr      decompressAndSet
skipLevelFour:
;; Aqui meteremos codigo para descomprimir el tercer nivel cuando lo tengamos. Pensar en mejor manera de realizar esto
    dec     a
    jr      nz, skipLevelFive
    call    enemy_creator_decrease_Delay
    call    enemy_creator_increase_Health
    ld      hl, #_level5_pack_end
    ld      de, #decompress_buffer_end5
    jr      decompressAndSet
skipLevelFive:
;; Aqui meteremos codigo para descomprimir el tercer nivel cuando lo tengamos. Pensar en mejor manera de realizar esto
    dec     a
    jr      nz, skipLevelSix
    call    enemy_creator_increase_Health
    call    enemy_creator_increase_Health
    ld      hl, #_level6_pack_end
    ld      de, #decompress_buffer_end6
    jr      decompressAndSet
skipLevelSix:
;; Aqui meteremos codigo para descomprimir el tercer nivel cuando lo tengamos. Pensar en mejor manera de realizar esto
    dec     a
    jr      nz, skipLevelSeven
    call    enemy_creator_increase_Health
    call    enemy_creator_decrease_Delay
    ld      hl, #_level7_pack_end
    ld      de, #decompress_buffer_end7
    jr      decompressAndSet
skipLevelSeven:
;; Aqui meteremos codigo para descomprimir el tercer nivel cuando lo tengamos. Pensar en mejor manera de realizar esto
    dec     a
    jr      nz, skipLevelEight
    call    enemy_creator_decrease_Delay
    ld      hl, #_level8_pack_end
    ld      de, #decompress_buffer_end8
    jr      decompressAndSet
skipLevelEight:
;; Aqui meteremos codigo para descomprimir el tercer nivel cuando lo tengamos. Pensar en mejor manera de realizar esto
    dec     a
    jr      nz, skipLevelNine
    call    enemy_creator_increase_Health
    ld      hl, #_level9_pack_end
    ld      de, #decompress_buffer_end9
    jr      decompressAndSet
skipLevelNine:
;; Aqui meteremos codigo para descomprimir el tercer nivel cuando lo tengamos. Pensar en mejor manera de realizar esto
    dec     a
    jr      nz, exitSkipLevel
    call    enemy_creator_increase_Health
    ld      hl, #_level10_pack_end
    ld      de, #decompress_buffer_end10
    jr      decompressAndSet
exitSkipLevel:
    ret

decompressAndSet:
    ;; (2B DE) dest_end	    Ending (latest) byte of the destination (decompressed) array
    ;; (2B HL) source_end	Ending (latest) byte of the source (compressed) array
    
    call    cpct_zx7b_decrunch_s_asm    ;; Destruye AF, BC, DE, HL

    ;; Una vez descomprimido, si es la primera vez tenemos que poner que habitacion apunte al nivel
    ld      hl, #decompress_buffer
    call    set_current_room        ;; Realizamos esto para meterlo en la primera habitacion del nuevo nivel

    ret
    call    cpct_zx7b_decrunch_s_asm    ;; Destruye AF, BC, DE, HL

    ;; Una vez descomprimido, si es la primera vez tenemos que poner que habitacion apunte al nivel
    ld      hl, #decompress_buffer
    call    set_current_room        ;; Realizamos esto para meterlo en la primera habitacion del nuevo nivel

    ret

game_setVictory:
    ld  a, #1
    ld (victoryPlayer), a
    ret

game_resetVictory:
    ld  a, #0
    ld (victoryPlayer), a
    ret