;;This file is part of Elfo saves Christmas.

    ;;Elfo saves Christmas is free software: you can redistribute it and/or modify
    ;;it under the terms of the GNU General Public License as published by
    ;;the Free Software Foundation, either version 3 of the License, or
    ;;(at your option) any later version.

    ;;Elfo saves Christmas is distributed in the hope that it will be useful,
    ;;but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;;GNU General Public License for more details.

    ;;You should have received a copy of the GNU General Public License
    ;;along with Elfo saves Christmas.  If not, see <https://www.gnu.org/licenses/>.
    
;; Include all CPCtelera constant definitions, macros and variables
.include "cpctelera.h.s"
.include "main.h.s"
.include "game.h.s"

.area _DATA
.area _CODE

;; La posicion inicial de los elementos

desplazamientoLateral = 20

firstElementPos     = 0xC000 + desplazamientoLateral
secondElementPos    = 0xC2D0 + desplazamientoLateral
thirdElementPos     = 0xC640 + desplazamientoLateral

;; Variable del Teclado
teclaReturn =       #Key_Esc
tecla_jugar =       #Key_1
tecla_controles =   #Key_2


;; Si esta a 1, salta el menu. TODO: Quitar antes de entrega
;; Cambiado a inmediato ya que no queremos que ocupe memoria. 
skipMenu    =     #0

;;
;; MAIN function. This is the entry point of the application.
;;    _main:: global symbol is required for correctly compiling and linking
;;
_main::
    ld      sp, #0x8000         ;; Nueva posicion de la pila
    ;; Disable firmware to prevent it from interfering with string drawing
    call cpct_disableFirmware_asm

    ld      de, #_array
    call cpct_akp_musicInit_asm
;;
    call cpct_akp_musicPlay_asm

    call ren_setPalette             ;; Destruye AF, BC, DE, HL. Pone paleta a usar de modo 1. Sólo hay que ejecutar una vez

    ld      a, #skipMenu
    dec     a 
    jr      nz, goMenu
    jp      jugar
    ;;call    game_start
goMenu:

    ld      c, #_tilemap_menu1_W
    ld      b, #_tilemap_menu1_H
    ld      de, #_tilemap_menu1_W
    ld      hl, #_tileset_menu_00
    call    cpct_etm_setDrawTilemap4x8_ag_asm   ;; Configuramos Primer Panel
    ld      hl, #firstElementPos
    ld      de, #_tilemap_menu1
    call    cpct_etm_drawTilemap4x8_ag_asm      ;; Dibujamos Primer Panel


    ld      c, #_tilemap_menu2_W
    ld      b, #_tilemap_menu2_H
    ld      de, #_tilemap_menu2_W
    ld      hl, #_tileset_menu_00
    call    cpct_etm_setDrawTilemap4x8_ag_asm   ;; Configuramos Primer Panel
    ld      hl, #secondElementPos
    ld      de, #_tilemap_menu2
    call    cpct_etm_drawTilemap4x8_ag_asm      ;; Dibujamos Primer Panel

    ld      c, #_tilemap_menu3_W
    ld      b, #_tilemap_menu3_H
    ld      de, #_tilemap_menu3_W
    ld      hl, #_tileset_menu_00
    call    cpct_etm_setDrawTilemap4x8_ag_asm   ;; Configuramos Primer Panel
    ld      hl, #thirdElementPos
    ld      de, #_tilemap_menu3
    call    cpct_etm_drawTilemap4x8_ag_asm      ;; Dibujamos Primer Panel

    ;; Cuando entramos en game, cambiamos de vuelta a modo 1 y dibujamos paleta

loop:
    call  cpct_scanKeyboard_asm 

    ;; ESPERA CAMBIO DE PANTALLA

    ld      hl, #tecla_jugar
    call    cpct_isKeyPressed_asm
    jr      z, notGame
jugar:
        call cpct_akp_stop_asm  ;; Paramos la música
        call game_start
        jp      goMenu
    notGame:

    ld hl, #tecla_controles
    call cpct_isKeyPressed_asm
    jr    z, notControls
    call drawControls        
    call controlsLoop
    jr  goMenu
    notControls:


    call cpct_akp_musicPlay_asm
   call cpct_waitVSYNC_asm

   ;; Loop forever
jr    loop

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SE ENCARGA DE ENSEÑAR LOS CONTROLES
;; TODO: REALIZAR LA PANTALLA DE CONTROLES FINAL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
drawControls:
    
    ;; TODO: Realizar tilemap con controles

    ld      c, #_tilemap_controls1_W
    ld      b, #_tilemap_controls1_H
    ld      de, #_tilemap_controls1_W
    ld      hl, #_tileset_menu_00
    call    cpct_etm_setDrawTilemap4x8_ag_asm   ;; Configuramos Primer Panel
    ld      hl, #firstElementPos
    ld      de, #_tilemap_controls1
    call    cpct_etm_drawTilemap4x8_ag_asm      ;; Dibujamos Primer Panel

    ld      c, #_tilemap_controls2_W
    ld      b, #_tilemap_controls2_H
    ld      de, #_tilemap_controls2_W
    ld      hl, #_tileset_menu_00
    call    cpct_etm_setDrawTilemap4x8_ag_asm   ;; Configuramos Primer Panel
    ld      hl, #secondElementPos
    ld      de, #_tilemap_controls2
    call    cpct_etm_drawTilemap4x8_ag_asm      ;; Dibujamos Primer Panel

    ld      c, #_tilemap_controls3_W
    ld      b, #_tilemap_controls3_H
    ld      de, #_tilemap_controls3_W
    ld      hl, #_tileset_menu_00
    call    cpct_etm_setDrawTilemap4x8_ag_asm   ;; Configuramos Primer Panel
    ld      hl, #thirdElementPos
    ld      de, #_tilemap_controls3
    call    cpct_etm_drawTilemap4x8_ag_asm      ;; Dibujamos Primer Panel

    ret
    
controlsLoop:
    call  cpct_scanKeyboard_asm 

    ld hl, #teclaReturn
    call cpct_isKeyPressed_asm
    jr    z, controls_return_not_pressed         
        jr endControlsLoop
controls_return_not_pressed:
   call cpct_akp_musicPlay_asm
   call cpct_waitVSYNC_asm

    jr controlsLoop
endControlsLoop:
    ret


