;;This file is part of Elfo saves Christmas.

    ;;Elfo saves Christmas is free software: you can redistribute it and/or modify
    ;;it under the terms of the GNU General Public License as published by
    ;;the Free Software Foundation, either version 3 of the License, or
    ;;(at your option) any later version.

    ;;Elfo saves Christmas is distributed in the hope that it will be useful,
    ;;but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;;GNU General Public License for more details.

    ;;You should have received a copy of the GNU General Public License
    ;;along with Elfo saves Christmas.  If not, see <https://www.gnu.org/licenses/>.
.include "main.h.s"
.include "cpctelera.h.s"
.include "player.h.s" ;; Incluye entity y render
.include "levels/Rooms1.h.s"
.include "game.h.s"


;; constantes de cambio de habitacion
;; pos: Posicion en X o en Y en el que tiene que estar el jugador para cambiar de habitacion
;; newPos: nueva posicion en X o Y en el que se encuentra el jugador una vez cambia de habitacion
;; newPointer: offset que le sumamos al puntero de habitacion para cambiar
exit_left_pos           = 1         ;; Si jugador esta en x, cambia de habitacion
exit_left_newPos        = 72        ;; Nueva posicion de x cuando cambiamos de habitacion por la izquierda
exit_left_newPointer    = -20       ;; BC = desplazamiento que sumaremos la puntero de habitacion actual (HL)

exit_right_pos          = 75         ;; Si jugador esta en x, cambia de habitacion
exit_right_newPos       = 4
exit_right_newPointer   = 20

exit_up_pos             = 6         ;; antes de llegar a 0
exit_up_newPos          = 136
exit_up_newPointer      = -1260     ;; 1260 = 60 (ancho de tilemap) * 21 altura de habitacion

exit_down_pos           = 150       ;; 200 - 16(alto de sprite) - 2 antes de colisionar
exit_down_newPos        = 16
exit_down_newPointer    = 1260      

;; constantes de jugador cuando empieza la partida, solo pondremos cosas que pueden cambiar durante la partida
xPos_default            = 21
yPos_default            = 64        ;; Altura siempre tiene que ser par
health_default          = 3
attack_default          = 1
shootDistance_default   = 20

;; bullet que usaremos para crear
DefineEntitySimple bullet, 0, 0, 0, 0, 1, 2, ent_move_bullet, 20

;; DefineEntityPlayer _name, _x, _y, _vx, _vy, _w, _h, _sprite, _level, _upd, _health, _attack, _shootDistance
;; Hero siempre tiene que tener altura par
DefineEntityPlayer hero_data, xPos_default, yPos_default, 0x00, 0x00, 0x04, 0x10, _movingPlayer_sp_0, player_moveKeyboard, health_default, attack_default, shootDistance_default ;; No esta puesto puntero a _balas y _enemigos

invicibility_time = 50
contador_vida: .db 0 ;; contador para inmunidad cuando te quitan vida                        
rateOfFire = 20     ;; Tiempo que tarda en disparar
shootTimerTest:         .db #rateOfFire      ;; Mientras tengamos pulsado la misma direccion de pulsado
                                             ;; Hay que cambiarlo a uno si pulsamos tecla diferente

player_key: .db 0

player_max_health = 10

teclaDisparoDerecha     = #Key_L
teclaDisparoIzquierda   = #Key_J
teclaDisparoArriba      = #Key_I
teclaDisparoAbajo       = #Key_K
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Resetea al jugador con los valores por defecto
;; REGISTROS DESTRUIDOS: IX
;; ENTRADA: -
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
player_reset:
    ld      a, #0
    ld  (contador_vida), a
    ld  (player_key), a
    ld      ix, #hero_data
    ld      de_x(ix), #xPos_default
    ld      de_y(ix), #yPos_default
    ld      e_he(ix), #health_default
    ld      e_at(ix), #attack_default
    ld  pl_shootDistance(ix), #shootDistance_default
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Devuelve en B, el ataque del enemigo
;; REGISTROS DESTRUIDOS: B, IX
;; ENTRADA: -
;; SALIDA:  B   -> Ataque enemigo
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
player_get_dmg:
    ld      ix, #hero_data
    ld      b, e_at(ix)
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Devuelve en B, el ataque del enemigo
;; REGISTROS DESTRUIDOS: B, IX
;; ENTRADA: -
;; SALIDA:  B   -> Ataque enemigo
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
player_get_health:
    push    ix
    ld      ix, #hero_data
    ld      b, e_he(ix)
    pop     ix
    ret 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Establece el viewport inicial del jugador segun
;; sus stats
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX, IY
;; ENTRADA: -
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
player_setInitialViewport:
    ld      ix, #hero_data
    ld      b, e_he(ix)             ;; Guardamos vidas que vamos a dibujar
    jp    ren_setInitialViewport    ;; Destruye AF, BC, DE, HL, IX, IY

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Modifica la variable de daño y la dibuja en el viewport
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX, IY
;; ENTRADA:
;;              A   -> 0: Guardamos que el jugador no tiene llave y borramos llave del viewport
;;                     1: Guardamos que el jugador tiene 1 llave y la dibujamos en el viewport
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
player_add_strength:
    ld      b, e_at(ix)
    inc     b
    ld  e_at(ix), b
    push    ix 
    call    ren_addStrengthViewport     ;; Destruye
    pop     ix      
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Modifica la variable de la llave y la dibuja o borra en el viewport
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX, IY
;; ENTRADA:
;;              A   -> 0: Guardamos que el jugador no tiene llave y borramos llave del viewport
;;                     1: Guardamos que el jugador tiene 1 llave y la dibujamos en el viewport
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
player_modify_key:
    ld  (player_key), a                 ;; Guardamos en la variable el valor de A
    call    ren_modifyKeyViewport       ;; Segun A dibujamos o borramos
    ret

;; TODO: Juntar add_health y remove_health segun la entrada
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Le suma 1 a la vida del jugador y actualiza viewport
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX, IY
;; ENTRADA: -
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
player_add_health:
    ld      ix, #hero_data
    ld      a, e_he(ix)
    cp      #player_max_health
    jr      z, skipAddHealth
    inc     a
    ld  e_he(ix), a                 ;; Nuevo valor de vida es vidaActual + 1
    call    ren_addHealthViewport   ;; Destruye AF, BC, DE, HL, IX, IY
skipAddHealth:
    ret 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; Le resta 1 a la vida del jugador y actualiza viewport
;;;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX, IY
;;;; ENTRADA: -
;;;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
player_remove_health:       ;; copiado y pegado de player_add_health
    ld a, (contador_vida)
    cp #0
    jr nz, salida		;;cuando es 0, se le acaba la inmunidad, cuando es mayor que 0 tiene inmunidad
    ld a, #invicibility_time
    ld (contador_vida), a
    ld      ix, #hero_data
    ld      a, e_he(ix)
    cp      #0
    jr z, salida		;; para no quitarle la vida
    dec     a
    ld  e_he(ix), a                 ;; Nuevo valor de vida es vidaActual - 1
    call    ren_removeHealthViewport;; Destruye AF, BC, DE, HL, IX, IY
salida:
    ret 


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Dibuja la habitación en la que se encuentra el 
;; jugador
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX, IY
;; ENTRADA: -
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
player_drawMap:
    call    get_current_room    ;; HL = Puntero a la habitacion del tilemap
    call    ren_setInitialMap   ;; Destruye AF, BC, DE, HL, IX, IY
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Cambia al jugador de habitación sumandole lo pasado
;; en BC
;; Casos:
;;  - Si suma 20 mueve habitacion derecha y si suma -20 izquierda
;;  - Si suma 1500 mueve abajo y si suma -1500 mueve arriba
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IY
;; ENTRADA:
;;          BC -> Desplazamiento a realizar
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
player_changeRoom:
    push    ix 
    call    get_current_room    ;; HL = puntero a HabitacionActual
    add     hl, bc              ;; HL = HabitacionActual + DesplazamientoHabitacion
    call    ent_loadEnemiesRoom ;; Destruye AF, BC, DE, IX. Carga enemigos en habitacion
    call    set_current_room    ;; Guardamos nueva posicion

    call player_drawMap         ;; Destruye AF, BC, DE, HL, IX, IY
    pop     ix
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Comprueba la colision con enemigos y si ha ocurrido
;; devuelve en el flag Z el resultado
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX, IY
;; ENTRADA: 
;;          IX  -> Puntero a jugador
;; SALIDA:  
;;          A   -> Devuelve 1 si ha colisionado
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
player_check_collision_enemies:
    ;; Checkeo de colision con enemigo
    
    ld      a, de_x(ix)
    add     b           ;; La nueva posicion es 1 a la izquierda
    ld      b, a        ;; B = Nueva posicion en X
    ld      a, de_y(ix)
    add     c
    ld      c, a        ;; C = Nueva posicion en Y

    ld      a, #1       ;; Ponemos a 1 para indicar que comprobamos colision de jugador con enemigos

    push    ix
    call    ent_check_collision_entities
    pop     ix
    
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Comprueba la colision con los tiles recogibles y
;; realiza las acciones correspondientes con el 
;; recogible
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX, IY
;; ENTRADA: 
;;          IX  -> Puntero a jugador
;; SALIDA:  
;;          A   -> Devuelve 1 si ha colisionado
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
check_collectible_collision:
    cp      #1                      ;; Recogible Vida
    jr      nz, skipLifeCheck
    push    ix
    call    player_add_health
    pop     ix
    jr      end
skipLifeCheck:

    cp      #2                      ;; Recogible Llave
    jr      nz, skipKeyCheck
    ld      a, #1                   ;; Le pasamos 1 para añadirlo al viewport
    push    ix
    call    player_modify_key          ;; player_modify_key incrementa llave a uno y lo dibuja
    pop     ix
    jr      end
skipKeyCheck:

    cp      #3                      ;; "Recogibla" escaleras para bajar a siguiente nivel
    jr      nz, skipLevelDownCheck
    ld      a, (player_key)
    dec     a
    jr      nz, skipLevelDownCheck         ;; Si no tenemos la llave no bajamos al siguiente nivel
    ;;      Si entra por aqui a es 0, lo reaprovecho como parametro para quitar la llave
    push    ix
    call    player_modify_key   ;; Destruye AF, BC, DE, HL, IX, IY
    call    game_incrementLevel
    call    game_setCurrentLevel
    call    player_drawMap          ;; Una vez cambiamos de mapa lo dibujamos
    pop     ix
    jr      end
skipLevelDownCheck:

    cp      #4                      ;; Recogible metralleta
    jr      nz, skipAddStrength
    ;; Subir daño de jugador en 1
    call    player_add_strength
    jr      end
skipAddStrength:

    cp      #5                      ;; Colision con santa. Gana jugador
    jr      nz, end
    call    game_setVictory

end:
    ret


;; TODO: esta funcion es muy grande y hace demasiados cosas. 
;; Ademas se ha creado haciendo copy paste por lo que seguramente se puede abstraer 
;; partes del codigo a sus propias funciones. 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Mueve al jugador comprobando colision, 
;; añade vida o la decrementa ( si recoge vida o recibe daño )
;; dispara
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX, IY
;; ENTRADA: 
;;          IX -> Puntero a jugador
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
player_moveKeyboard: 
    ;; CODIGO DE INVULNERABILIDAD   ;;      Aqui no hace falta ver colision cada frame ya que el enemigo puede detectar colision con jugador y llamar a player_remove_health
    ;; Controlamos la inmunidad del jugador
    ld      a, (contador_vida)
    or      a                           ;; Equivalente a cp #0 pero ahorramos un byte
    jr      z, skipChangeInvincibility  ;; Si A = 0 (no invulnerable),no modificamos el contador de invulnerabilidad, lo dejamos a 0
    
    ;; Por cada ciclo que sea invulnerable, restamos 1 y lo actualizamos
    dec     a                         
    ld  (contador_vida), a              ;; Guardamos nuevo valor de contador de invulnerabilidad
skipChangeInvincibility:
    ;; CODIGO DE INVULNERABILIDAD ACABADO  ;;

    ;; CODIGO DE MOVIMIENTO ;;
    call  cpct_scanKeyboard_asm     ;; Destruye AF, BC, DE, HL. Scaneo estado de las teclas
    ld      hl, #Key_A
    call    cpct_isKeyPressed_asm   ;; Destruye A, D, BC, HL. Miramos si A esta pulsada
    jp      z, a_no_pulsada
    ;; Si a es pulsada miramos el tile a la derecha del jugador

    ;; Consideraciones sobre colision con recogibles:
    ;; Nos podemos ahorrar llamadas a ent_check_collission devolviendo en vez de cero en 1
    ;; byte y dependiendo de que bit este a 1, sabemos con que ha colisionado
    ;; El checkeo de recogible se podria hacer una vez nos movamos para simplificar el codigo

    ld      bc, #0xFF00     ;; En BC pasamos lo que nos desplazamos
    call    player_check_collision_enemies
    dec     a                         ;; Si a = 1, es que ha colisionado
    jr      nz, keepChecking1         ;; Si no da 0, miramos otras colisiones

    push    ix
    call player_remove_health
    pop     ix

    jp      d_no_pulsada            ;; d_no pulsada para comenzar a mirar en el eje Y     

keepChecking1:
    ;; Checkeo de colision
    ld      a, #3
    ld      bc, #0xFF00             ;; B = lo que sumamos a X, C = lo que sumamos a Y
    ld      de, #_rooms1_W          ;; Miraremos colision en tiles de abajo
    set     7, d                    ;; Para indicar que es checkeo en horizontal
    call    ent_check_collision     ;; Devuelve en Flag Z si colisiona o no
    jr      z, a_no_pulsada         ;; Si da 0, es que colisionamos y no nos movemos

    call    check_collectible_collision

    ;; Comprobamos cambio de habitacion
    ld      a, de_x(ix)
    cp      #exit_left_pos              ;; Si colisiona con el lado izquierdo
    jr      nz, noRoomSwitchLeft
    ld      de_x(ix), #exit_left_newPos ;; Lo ponemos en la parte izquierda de la habitacion
    ld      bc, #exit_left_newPointer   ;; BC = desplazamiento que sumaremos a la habitacion actual (HL)

    call    player_changeRoom        ;; Destruye AF, BC, DE, HL, IY

    jp      d_no_pulsada
noRoomSwitchLeft:
    ;; Si no ha colisionado en los 2 tiles de arriba entonces se mueve
    ld      hl, #_movingPlayer_sp_2     
    ld      de_sp_l(ix) , l
    ld      de_sp_h(ix) , h
    ld      e_vx(ix), #-1
a_no_pulsada:

    ld      hl, #Key_D
    call    cpct_isKeyPressed_asm  ;; Destruye A, D, BC, HL. Miramos si D esta pulsada
    jp      z, d_no_pulsada

    ld      bc, #0x0100     ;; En BC pasamos lo que nos desplazamos
    call    player_check_collision_enemies
    dec     a                         ;; Si a = 1, es que ha colisionado
    jr      nz, keepChecking2         ;; Si no da 0, miramos otras colisiones

    push    ix
    call player_remove_health
    pop     ix

    jp      d_no_pulsada            ;; d_no pulsada para comenzar a mirar en el eje Y     

keepChecking2:

    ;; Checkeo de colision
    ld      a, #3
    ld      bc, #0x0400             ;; B = lo que sumamos a X, C = lo que sumamos a Y
    ld      de, #_rooms1_W          ;; Miraremos colision en tiles de abajo
    set     7, d                    ;; Para indicar que es checkeo en horizontal
    call    ent_check_collision     ;; Devuelve en Flag Z si colisiona o no
    jr      z, d_no_pulsada         ;; Si da 0, es que colisionamos y no nos movemos

    call    check_collectible_collision

    ;; Comprobamos cambio de habitacion
    ld      a, de_x(ix)
    cp      #exit_right_pos                     ;; Si colisiona con el lado derecho
    jr      nz, noRoomSwitchRight
    ld      de_x(ix), #exit_right_newPos   ;; Lo ponemos en la parte izquierda de la habitacion
    ld      bc, #exit_right_newPointer      ;; BC = desplazamiento que sumaremos a la habitacion actual (HL)

    call    player_changeRoom       ;; Destruye AF, BC, DE, HL, IX, IY

    jr      d_no_pulsada
noRoomSwitchRight:
    ;; Si no ha colisionado en los 2 tiles de arriba, ni se mueve de habitacion entonces se mueve
    ld      hl, #_movingPlayer_sp_1     
    ld      de_sp_l(ix) , l
    ld      de_sp_h(ix) , h
    
    ld      e_vx(ix), #1
    
d_no_pulsada:

    ;; Modificamos a la nueva posicion para evitar colision en diagonal
    call  ent_move ;; Destruye AF. Actualiza posicion segun velocidad modificada por teclado
    ;; Reseteamos la velocidad en X
    ld e_vx(ix), #0

    ld      hl, #Key_W
    call    cpct_isKeyPressed_asm  ;; Destruye A, D, BC, HL. Miramos si W esta pulsada
    jp      z, w_no_pulsada 

    ld      bc, #0x00FF     ;; En BC pasamos lo que nos desplazamos
    call    player_check_collision_enemies
    dec     a                         ;; Si a = 1, es que ha colisionado
    jr      nz, keepChecking3         ;; Si no da 0, miramos otras colisiones

    push    ix
    call player_remove_health
    pop     ix

    jp      s_no_pulsada            ;; d_no pulsada para comenzar a mirar en el eje Y     

keepChecking3:

    ;; Checkeo de colision
    ld      bc, #0x00FE             ;; B = lo que sumamos a X, C = lo que sumamos a Y
    ld      de, #0x0001             ;; Miraremos un tile a la derecha cuando no este alineado
    call    ent_check_collision     ;; Devuelve en Flag Z si colisiona o no y an a info sobre recogibles
    jr      z, w_no_pulsada         ;; Si da 0, es que colisionamos y no nos movemos
    
    call    check_collectible_collision

    ;; Comprobamos cambio de habitacion
    ld      a, de_y(ix)
    ;; CAMBIAR CUANDO CAMBIEMOS VIEWPORT
    cp      #exit_up_pos                     ;; Si colisiona con parte de abajo. 183 = 199 - 16 - 1(porque tiene que ser par)
    jr      nz, noRoomSwitchUp
    ld      de_y(ix), #exit_up_newPos            ;; Lo ponemos en la parte de abajo de la habitacion
    ld      bc, #exit_up_newPointer               ;; 1500 = 60 (ancho de tilemap) * 25 anchura de habitacion

    call    player_changeRoom         ;; Destruye AF, BC, DE, HL, IX, IY

    jp      s_no_pulsada
noRoomSwitchUp:
    ld      hl, #_movingPlayer_sp_3     
    ld      de_sp_l(ix) , l
    ld      de_sp_h(ix) , h

    ld      e_vy(ix), #-2

w_no_pulsada:
    ld    hl, #Key_S
    call  cpct_isKeyPressed_asm  ;; Destruye A, D, BC, HL. Miramos si S esta pulsada
    jp    z, s_no_pulsada 

    ld      bc, #0x0001     ;; En BC pasamos lo que nos desplazamos
    call    player_check_collision_enemies
    dec     a                         ;; Si a = 1, es que ha colisionado
    jr      nz, keepChecking4         ;; Si no da 0, miramos otras colisiones

    push    ix
    call player_remove_health
    pop     ix

    jp      s_no_pulsada            ;; d_no pulsada para comenzar a mirar en el eje Y     

keepChecking4:

    ld      a, #3
    ld      bc, #0x0010         ;; B = lo que sumamos a X, C = lo que sumamos a Y
    ld      de, #0x0001         ;; Miraremos un tile a la derecha cuando no este alineado
    call    ent_check_collision ;; Devuelve en Flag Z si colisiona o no
    jr      z, s_no_pulsada     ;; Si da 0, es que colisionamos y no nos movemos

    call    check_collectible_collision

    ;; Comprobamos cambio de habitacion
    ld      a, de_y(ix)
    ;; CAMBIAR CUANDO CAMBIEMOS EL VIEWPORT
    cp      #exit_down_pos                     ;; Si colisiona con parte de abajo. 183 = 199 - 16 - 1(porque tiene que ser par)
    jr      nz, noRoomSwitchDown
    ld      de_y(ix), #exit_down_newPos    ;; Lo ponemos en la parte de arriba de la habitacion
    ld      bc, #exit_down_newPointer       ;; 1500 = 60 (ancho de tilemap) * 25 anchura de habitacion

    call    player_changeRoom        ;; Destruye AF, BC, DE, HL, IX, IY

    jr      s_no_pulsada
noRoomSwitchDown:
    ld      hl, #_movingPlayer_sp_0     
    ld      de_sp_l(ix) , l
    ld      de_sp_h(ix) , h
    ld e_vy(ix), #2

s_no_pulsada:
    call  ent_move ;; Destruye AF. Actualiza posicion segun velocidad modificada por teclado
    ;; Reseteamos las velocidades
    ld e_vy(ix), #0
;; CODIGO DE MOVIMIENTO ACABADO ;;

;; CODIGO DE DISPARO ;;
    ld      hl, #teclaDisparoIzquierda
    call    cpct_isKeyPressed_asm   ;; Destruye A, D, BC, HL. Miramos si CursorLeft esta pulsada
    jr      z, left_no_pulsada
    ld      hl, #_movingPlayer_sp_2     
    ld      de_sp_l(ix) , l
    ld      de_sp_h(ix) , h

    ld      bc, #0x0007         ;; X = X, Y = Y + 8
    ld      de, #0xFF00         ;; VX = -1 
    call    player_set_bullet   ;; Destruye AF, BC
    jr      down_no_pulsada ;; En estos casos nos aseguramos de no spawnear más disparos, No queremos que el jugador dispare en más de 1 direccion a la vez
left_no_pulsada:

    ld      hl, #teclaDisparoDerecha
    call  cpct_isKeyPressed_asm     ;; Destruye A, D, BC, HL. Miramos si CursorRight esta pulsada
    jr    z, right_no_pulsada

    ld      hl, #_movingPlayer_sp_1     
    ld      de_sp_l(ix) , l
    ld      de_sp_h(ix) , h

    ld      a, de_x(ix)
    add     #56
    jp      m, down_no_pulsada        ;; Impedir que dispare si esta en esta posicion

    ld      bc, #0x0407         ;; X = X + 4, Y = Y + 8
    ld      de, #0x0100         ;; VX = 1 
    call    player_set_bullet   ;; Destruye AF, BC
    jr      down_no_pulsada ;; En estos casos nos aseguramos de no spawnear más disparos
right_no_pulsada:

    ld      hl, #teclaDisparoArriba
    call  cpct_isKeyPressed_asm     ;; Destruye A, D, BC, HL. Miramos si CursorUp esta pulsada
    jr    z, up_no_pulsada
    ld      hl, #_movingPlayer_sp_3
    ld      de_sp_l(ix), l 
    ld      de_sp_h(ix), h

    ld      a, de_y(ix)
    bit     7, a                ;; Si es negativo
    jr      nz, negativeY1
    add     #-10
    jp      m, up_no_pulsada        ;; Impedir que dispare si esta en esta posicion
negativeY1:
    ld      bc, #0x0200         ;; X = X + 2, Y = Y 
    ld      de, #0x00FE         ;; VY = -2 
    call    player_set_bullet   ;; Destruye AF, BC
    jr      down_no_pulsada ;; En estos casos nos aseguramos de no spawnear más disparos
up_no_pulsada:

ld      hl, #teclaDisparoAbajo
    call  cpct_isKeyPressed_asm     ;; Destruye A, D, BC, HL. Miramos si CursorDown esta pulsada
    jr    z, down_no_pulsada
    ld      hl, #_movingPlayer_sp_0
    ld      de_sp_l(ix), l 
    ld      de_sp_h(ix), h

    ld      a, de_y(ix)
    bit     7, a                ;; Si es negativo es cuando miramos
    jr      z, negativeY2
    add     #22                ;; 150 - 22 = 128 (negativo)
    jp      m, down_no_pulsada        ;; Impedir que dispare si esta en esta posicion
negativeY2:
    ld      bc, #0x0210         ;; X = X + 2, Y = Y + 16
    ld      de, #0x0002         ;; VY = 2
    call    player_set_bullet   ;; Destruye AF, BC
down_no_pulsada:

;; CODIGO DE DISPARO ACABADO ;;
    xor     a
    inc     a   ;; Para asegurarnos que no devuelva flag Zero activado
    ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Configura datos iniciales de disparo si lo permite
;; el temporizador
;; REGISTROS DESTRUIDOS: AF, BC
;; ENTRADA: 
;;          BC -> B lo que sumamos a X, C lo que sumamos a Y
;;          DE -> D velocidad en X, E velocidad en Y
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
player_set_bullet:
    ;; Código de temporizador para no disparar muchas balas en poco tiempo
    ld      a, (shootTimerTest)
    dec     a
    jr      nz, skipShootRight  ;; Mientras temporizador no vuelva a 0. No creamos disparo
    
    ;; Posicion inicial de la bala en x
    ld      a, de_x(ix)         ;; Cargamos posicion de x actual del jugador
    add     b                   
    ld      b, a                ;; B = X + Desplazamiento segun direccion

    ;; Posicion inicial de la bala en y
    ld      a, de_y(ix)         ;; Cargamos posicion de y actual del jugador 
    add     c                   
    ld      c, a                ;; C = Y + Desplazamiento segun direccion

    ld      a, pl_shootDistance(ix) ;; A = Distancia del disparo

    push    ix                  ;; Guardamos puntero a jugador

    ;; Modificamos bullet que es lo que añadiremos al sistema de entidades
    ld      ix, #bullet
    ld      es_distance(ix), a  ;; Distancia tomada del jugador
    ld      de_x(ix), b         ;; Posicion donde empieza disparo X
    ld      de_y(ix), c         ;; Posicion donde empieza disparo Y
    ld      es_vx(ix), d        
    ld      es_vy(ix), e        ;; Velocidad de Bala pasada
    
    pop     ix                  ;; Hemos acabado usando ix para modificar bullet

    ld      a, #rateOfFire      ;; Reseteamos temporizador si disparamos
    skipShootRight:
    ld  (shootTimerTest), a     ;; Actualizamos temporizador disparemos o no
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Realiza clear del bullet
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX, IY
;; ENTRADA: -
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
player_clear_bullet:
    ld      ix, #bullet
    ld      a, de_x(ix)
    or      a            ;; Si a es 0 no realizamos el clear
    jr      z, skipClear
    call    ent_clear    ;; Destruye AF, BC, DE, HL, IX, IY.
skipClear:
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Realiza update del bullet, comprueba ademas si ha
;; habido colision con algun enemigo.
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX, IY
;; ENTRADA: -
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
player_update_bullet:
    ld      ix, #bullet
    call    ent_move_bullet
    ld      b, de_x(ix)
    ld      c, de_y(ix)      
    ld      hl, #ent_check_colision_bullet_enemy    ;; Destruye  AF, BC, DE, HL, IX, IY
    push    ix          
    call    enemy_doThisForAll          ;; Destruye AF, BC, DE, HL, IX
    pop     ix
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Realiza draw del bullet.
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX
;; ENTRADA: -
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
player_draw_bullet:
    ld      ix, #bullet
    call    ent_draw_bullet     ;; Destruye AF, BC, DE, HL      
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Resetea el bullet poniendo x en 0
;; REGISTROS DESTRUIDOS: IX
;; ENTRADA: -
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
player_reset_bullet:
    ld      ix, #bullet
    ld  de_x(ix), #0        ;; X_bullet = 0
    ret
