;;This file is part of Elfo saves Christmas.

    ;;Elfo saves Christmas is free software: you can redistribute it and/or modify
    ;;it under the terms of the GNU General Public License as published by
    ;;the Free Software Foundation, either version 3 of the License, or
    ;;(at your option) any later version.

    ;;Elfo saves Christmas is distributed in the hope that it will be useful,
    ;;but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;;GNU General Public License for more details.

    ;;You should have received a copy of the GNU General Public License
    ;;along with Elfo saves Christmas.  If not, see <https://www.gnu.org/licenses/>.

.include "entity.h.s"       ;; Para utilizar distance de bala
.include "main.h.s"
.include "levels/Rooms1.h.s"
.include "levels/viewport.h.s"


initialHealthTilemapPos = 0
initialHealthVideoPos   = 0xC6F0

viewportHealthTilemap:  .dw #initialHealthTilemapPos ;; Puntero en el lugar donde dibujará vida del tilemap
viewportHealthVideo:    .dw #initialHealthVideoPos ;; Puntero en la posicion de memoria donde dibujar la cuarta vida ( C6E0 + 10 )
viewportHealthAmount:   .db #0      ;; Si esto es igual al maximo de vida, entonces no añadir más
                                    ;; También cuando sea 5 cambiar puntero a uno abajo

viewportKeyTileMapPos   = 28        ;; Posicion del tilemap a cambiar cuando añadimos o quitamos llave
viewportKeyVideo        = 0xC700    ;; Posicion donde dibujaremos y borramos la llave. Solo tenemos una llave por nivel

;; Sólo vamos a tener 3 mejoras de daño en todo el juego
initialviewportSMGTileMapPos    = 35
initialviewportSMGVideo         = 0xC71C


viewportSMGTileMapPos:  .dw #initialviewportSMGTileMapPos ;; Puntero en el lugar donde dibujará vida del tilemap
viewportSMGVideo:       .dw #initialviewportSMGVideo ;; Puntero en la posicion de memoria donde dibujar la cuarta vida ( C6E0 + 10 )

spriteVida          = 41
spriteContenedor    = 40
spriteLlave         = 8
spriteFondoViewport = 6
spriteMetralleta    = 12

maxVida             = 10     ;; Cambiarlo a stat del jugador

viewport_video_start        = 0xC690    ;; Los 4 ultimos tiles de abajo
viewport_video_changeDown   = 0xC734    ;; Posicion donde dibujaria la sexta vida cuando recoga vida
viewport_video_changeUp     = 0xC6F4    ;; Reposicionamiento a zona donde dibujaria quinta vida
room_video_start            = 0xC000    ;; Posicion de memoria de video donde dibujaremos la habitacion

tilesetPos:         .dw #_tileset1_sp_00        ;; Posiblemente lo cambiaremos porque no lo comprimiremos
tile_borde_viewport         = 20                 ;; Tile de borde del viewport para resetear
m_front_buffer: .db 0xC0
m_back_buffer:  .db 0x80


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Limpia y prepara un nuevo buffer
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL
;; ENTRADA: -
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ren_newScene:
    call    ren_switchBuffers

    ;;call    ren_clearBackBuffer
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Inicializa el back buffer a 0
;; REGISTROS DESTRUIDOS: BC, DE, HL
;; ENTRADA: -
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ren_clearBackBuffer:
    ;;ld      a, (m_back_buffer)
    ;;ld      h, a
    ;;ld      l, #0
    ;;ld      (hl), #0 
    ;;ld      d, a
    ;;ld      e, #1
    ;;ld      bc, #0x4000 - 1 ;; BC = Bytes de buffer -1 porque ya hemos borrado 8000
    ;;ldir    ;; Para 3FFF posiciones se copiara en DE(HL+1) contenido de HL que siempre sera 0
              ;; ldir incrementa hl y de  y decrementa BC. Cuando BC es 0, paro

    ld      a, (m_back_buffer)
    ld      h, a
    ld      de, #0              ;; DE = 0
    ld      l, e                ;; HL = 0x BACK_BUFFER 00
    ld      bc, #0x4000         ;; BC = Num de bytes a copiar
    call cpct_memset_f64_asm
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Intercambia m_front_buffer y m_back_buffer y 
;; cambia el registro del CRTC
;; REGISTROS DESTRUIDOS: AF, BC, HL
;; ENTRADA: -
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ren_switchBuffers:
    ld      a, (m_back_buffer)  
    ld      b, a                ;; B = m_back_buffer
    ld      a, (m_front_buffer) ;; A = m_front_buffer
    ld  (m_back_buffer), a      ;; m_back_buffer = m_front_buffer
    ld      a, b                ;; A = m_back_buffer
    ld  (m_front_buffer), a     ;; m_front_buffer = m_back_buffer

    ;; Desplazamiento ya que llamada usa los 6 bits menos significativos
    srl     b
    srl     b       ;; Desplazo B dos bits a la derecha
    ld      l, b    ;; L = los 6 bits menos significativos del back_buffer
    jp cpct_setVideoMemoryPage_asm ;; Destruye F, BC, HL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Dibuja una bala
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL
;; ENTRADA: 
;;          IX -> Puntero a bala
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ren_drawBullet:
    ld      e, de_x(ix)
    dec     e
    inc     e
    jr      z, skipDrawBullet   ;; Si x es 0( Valor por defecto y cuando se destruye), no dibuja

    ld      e, es_distance(ix)
    dec     e
    jr      z, skipDrawBullet   ;; No lo dibujaremos cuando quede 1 de distancia para que no se quede en el front_buffer

    ld      de, #0xC000
    ld      c, de_x(ix)
    ld      b, de_y(ix)
    call    cpct_getScreenPtr_asm  ;; Destruye AF, BC, DE, HL. Devuelve en HL puntero a memvid

    call    ren_getHOffset      ;; Destruye AF, B. B = Offset
    ex      de, hl              ;;
    ld      a, (m_back_buffer)
    add     b
    ld      d, a                ;; DE = back_buffer + Offset          
    ld      a, #0x00            
    ld      bc, #0x0101        

    call    cpct_drawSolidBox_asm ;; Destruye AF, BC, DE, HL
skipDrawBullet:
    ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Dibuja la entidad con sprite pasada por ix
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL
;; ENTRADA: 
;;          IX -> Puntero a entidad
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ren_drawEntity:
    ld      a, (m_back_buffer)
    ld      d, a 
    ld      e, #0x00            ;; DE = Back Buffer

    ld      c, de_x(ix)         ;; C = Entity X
    ld      b, de_y(ix)         ;; B = Entity Y
    call cpct_getScreenPtr_asm  ;; Destruye AF, BC, DE, HL. Devuelve en HL puntero a memvid

    ex      de, hl              ;; DE = Puntero a memoria
    ld      l, de_sp_l(ix)
    ld      h, de_sp_h(ix)      ;; HL = Puntero a sprite
    ld      b, de_h(ix)         ;; alto
    ld      c, de_w(ix)         ;; Ancho
    jp      cpct_drawSpriteMasked_asm ;; Destruye AF, BC, DE, HL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Configura la paleta inicial
;; NOTA: Se puede cambiar para que reciba paleta distinta
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL
;; ENTRADA: -
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ren_setPalette:
    ld      de, #4                  ;; Cargamos 4 colores
    ld      hl, #_g_palette         ;; Cargamos paleta que queremos usar. Esto sólo se tiene que hacer una vez. Hay que cambiarlo
    jp      cpct_setPalette_asm     ;; Destruye AF, BC, DE, HL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Obtiene el offset de la direccion pasada para
;; que se pueda sumar y obtener la misma posicion tanto
;; en el back_buffer como el front_buffer.
;; REGISTROS DESTRUIDOS: AF, B
;; ENTRADA:
;;          H -> primer byte de la posicion de memoria de video
;; SALIDA: 
;;          B -> El offset que se le sumara al back o front buffer
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ren_getHOffset:
    ld      b, #0xC0
    ld      a, h
    sub     b           ;; A = H - C0
    ld      b, a        ;; B = H - C0
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Cambia el viewport de lo que se va a dibujar
;; REGISTROS DESTRUIDOS: AF, DE, HL
;; ENTRADA: 
;;          C  -> Anchura en tiles de vista a dibujar
;;          B  -> Altura en tiles de vista a dibujar
;;          DE -> Anchura en tiles del tilemap que vamos a usar
;; SALIDA:  -   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ren_setDrawMap:
    ld      hl, (#tilesetPos)                ;; Puntero al principio de la definición de los tilesets
    jp      cpct_etm_setDrawTilemap4x8_ag_asm   ;; Destruye AF, DE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Dibuja el mapa en el que se encuentra el jugador
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX, IY
;; ENTRADA:
;;          C  -> Si es 1 dibujar en back_buffer
;;                Sino (0) dibujar en front_buffer
;;          DE -> Puntero a parte del tilemap a usar
;;          HL -> Puntero a posicion donde vamos a dibujar en pantalla
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ren_drawMap:
    call    ren_getHOffset      ;; Destruye AF, B. B = Offset
    dec     c   
    jr      z, drawFront        ;; Si C - 1 = 0, dibujamos en front_buffer
    ld      a, (m_back_buffer)    ;; Sino en back_buffer. A = back_buffer
    jr      drawBack
drawFront:
    ld      a, (m_front_buffer)   ;; A = front_buffer
drawBack:
    add     b                   ;; A = A + B ( offset de H )
    ld      h, a                ;; H = A
    jp      cpct_etm_drawTilemap4x8_ag_asm   ;; Destruye AF, BC, DE, HL, IX, IY

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Dibuja la habitación en la que se encuentra el 
;; jugador en los dos buffers
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX, IY
;; ENTRADA: 
;;          HL -> Puntero a la habitacion del tilemap
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ren_setInitialMap:
    push    hl 

    ld     bc, #0x1514      ;; b (altura)= 21 y c(anchura) = 20, cada habitacion es de 20*21
    ld     de, #_rooms1_W   
    call ren_setDrawMap     ;; Destruye AF, DE, HL

    pop     hl 
    ex      de, hl              ;; DE = HL

    ld      hl, #room_video_start   ;; Tile 0 = C000. Es la posicion de memoria de video donde queremos dibujar nivel
    ld      c, #1                   ;; 1 = dibujar back_buffer
    push    de 
    call ren_drawMap            ;; Destruye AF, BC, DE, HL, IX, IY

    pop     de
    ld      hl, #room_video_start   ;; Tile 0 = C000. Es la posicion de memoria de video donde queremos dibujar nivel
    ld      c, #0                   ;; 0 = Dibujar front_buffer
    call ren_drawMap            ;; Destruye AF, BC, DE, HL, IX, IY
    ret



;;;;;;;;;;;;;;; VIEWPORT ;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Establece el viewport inicial del jugador segun
;; sus stats, dibujando en los dos buffers
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX, IY
;; ENTRADA:
;;          B -> Numero de vidas del jugador
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;    ;; Arreglar error de redibujado cuando muere o sale al menu principal
ren_setInitialViewport:

    ;; Reseteamos valores del daño para que cuando muera se posiciona el tile de daño correctamente
    ld      hl, #viewportSMGTileMapPos
    ld      (hl), #initialviewportSMGTileMapPos
    ld      hl, #viewportSMGVideo
    ld      (hl), #initialviewportSMGVideo

    ;; Dejamos el viewport "limpio"
    ld      de, #_viewport_W
    ld      hl, #_viewport
    add     hl, de
    inc     hl                  ;; Posicion donde se dibuja primera vida
    ld      a,  #5
continueInc:
    ld  (hl), #spriteFondoViewport                ;; Tile de fondo
    inc     hl
    dec     a
    jr      nz, continueInc

    add     hl, de
    ld      a, #6
continueDec:
    ld  (hl), #spriteFondoViewport                ;; Tile de fondo
    dec     hl
    dec     a
    jr      nz, continueDec

    ld      hl, #initialHealthTilemapPos
    ld  (viewportHealthTilemap), hl
    ld      hl, #initialHealthVideoPos
    ld  (viewportHealthVideo), hl           ;; Cargamos valores por defecto para cuando muera el jugador

    push    bc                      ;; Metemos vidas en stack
    ld      hl, #_viewport          ;; Puntero al viewport
    ld      bc, #_viewport_W        ;; Anchura viewport. Al sumar nos desplazamos un tile abajo
    add     hl, bc                  ;; Fila donde se dibuja primera vida
    inc     hl                      ;; Columna donde se dibuja primera vida

    ;; NOTA: Esto lo quitariamos si el jugador empieza con menos de 5 vidas
    ;; Manejo para dejar en hl y de pos vida 1 y 6, respectivamente
    add     hl, bc                  ;; HL = pos vida 6 
    ex      de, hl                  ;; De = pos vida 6
    ld      hl, #0                  ;; HL = 0
    add     hl, de                  ;; HL = pos vida 6
    or      a                       ;; Reset flag carry
    sbc     hl, bc                  ;; HL = pos vida 1

    pop     bc                      ;; Restauramos vidas en B    
    ld      a, b                    ;; para poner en posicion de memoria tiene que ser con a
    ld  (#viewportHealthAmount), a  ;; Guardamos vida inicial de jugador en variable
continueHealth:
    ld      (hl), #spriteVida       ;; Cambiamos viewport con tile de vida
    inc     hl                      ;; Desplazamos a la derecha
    dec     b                       ;; decrementamos cantidad vida
    jr      z, healthFinished       ;; Si ya no hay más vida, para
    ld      a, b                    ;; metemos en a cantidad vida
    sub     #5                      ;; restamos 5
    jr      nz, continueHealth      ;; Si no es 0 seguimos dibujando en siguiente columna
    ex      de, hl                  ;; metemos en hl posicion a la sexta vida ( siguiente fila)
    jr continueHealth
healthFinished:
    ;; _viewport modificado con vida del jugador
    ld  (viewportHealthTilemap), hl        ;; Guardamos posicion donde dibujaría siguiente vida

    ld     bc, #0x0414      ;; b (altura)= 4 y c(anchura) = 20
    ld     de, #_viewport_W ;; Igual que rooms
    call ren_setDrawMap     ;; Destruye AF, DE, HL

    ld	    de, #_viewport
    ld      hl, #viewport_video_start   ;; Posicion de memoria de video donde dibujar el viewport
    ld	    c, #1           ;; 1 = dibujar back_buffer
    call ren_drawMap        ;; Destruye AF, BC, DE, HL, IX, IY

    ld	    de, #_viewport
    ld      hl, #viewport_video_start   ;; Posicion de memoria de video donde dibujar el viewport
    ld	    c, #0           ;; 0 = dibujar front_buffer
    call ren_drawMap        ;; Destruye AF, BC, DE, HL, IX, IY

    ret

;; TODO: Juntar addHealthViewport y removeHealthViewport a modifyHealthViewport

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Dibuja la vida nueva y modifica las variables
;; relacionadas con la vida.
;; A viewportHealthTilemap , lo posiciona en el proximo tile de vida del tilemap
;; A viewportHealthVideo   , lo posiciona en el proximo tile de vida de la memoria de video
;; A viewportHealthAmount  , le añade uno
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX, IY
;; ENTRADA: -
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ren_addHealthViewport:
    ;; Primero cambiamos tileset y dibujamo y luego cambiamos variables
    ld      hl, (viewportHealthTilemap)        ;; Guardamos posicion donde dibujaría siguiente vida
    ld      (hl), #spriteVida                  ;; Cambiamos tileSet del viewport

    ;;          C  -> Anchura en tiles de vista a dibujar
    ;;          B  -> Altura en tiles de vista a dibujar
    ;;          DE -> Anchura en tiles del tilemap que vamos a usar
    ld      bc, #0x0101
    ld      de, #_viewport_W
    call    ren_setDrawMap  ;; Destruye AF, DE, HL

    ;;          DE -> Puntero a parte del tilemap a usar
    ;;          HL -> Puntero a posicion donde vamos a dibujar en pantalla
    ld      de, (viewportHealthTilemap)
    ld      hl, (viewportHealthVideo)
    ld      c, #1           ;; 1 = dibujar back_buffer
    call    ren_drawMap     ;; Destruye AF, BC, DE, HL, IX, IY

    ;;;  Hay que averiguar una forma de realizar esto en el ren_newScene    ;;
    ;;;  Actualmente tiene el mismo comportamiento que cuando no usabamos doble
    ;;;  buffer. Hay un flicker en el personaje cuando añadimos vida o quitamos
    ;;          DE -> Puntero a parte del tilemap a usar
    ;;          HL -> Puntero a posicion donde vamos a dibujar en pantalla
    ld      de, (viewportHealthTilemap)
    ld      hl, (viewportHealthVideo)
    ld      c, #0           ;; 0 = dibujar front_buffer
    call    ren_drawMap     ;; Destruye AF, BC, DE, HL, IX, IY
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    ld      a, (viewportHealthAmount)           ;; Cargamos valor inicial de vida
    ld      hl, (viewportHealthTilemap)         ;; Guardamos posicion donde dibujaría siguiente vida
    sub     #4                                  ;; Empieza en 0 por lo que cuando es 4 hay 5 vidas dibujadas en primare linea
    jr      z, changeDown                       ;; Si es 0 nos desplazamos abajo
    inc     hl                                  ;; Dibujar a la deracha
    ld  (viewportHealthTilemap), hl             ;; guardamos tile a la derecha
    ld      hl, (viewportHealthVideo)           
    ld      bc, #4
    add     hl, bc
    ld  (viewportHealthVideo), hl               ;; Posicion en memoria un tile a la derecha
    jr      notChangeDown
changeDown:
    ld      bc, #_viewport_W
    add     hl, bc 
    ld      bc, #5
    or      a                                   ;; Reset carry flag
    sbc     hl, bc
    ld  (viewportHealthTilemap), hl             ;; Guardamos posicion un tile abajo y 5 hacia atrás. Es el salto de 5 a 6 vidas
    ld      hl, #viewport_video_changeDown      ;;        
    ld  (viewportHealthVideo), hl               ;; Posicion donde dibujariamos vida 6
notChangeDown:
    ;; comun a los dos casos
    ld      a, (viewportHealthAmount)
    inc     a 
    ld  (viewportHealthAmount), a               ;; Añadimos uno al contador de vida
    
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; Modifica las variables relacionadas con la vida y
;;;; dibuja encima de la vida que ha perdido.
;;;; A viewportHealthTilemap , lo posiciona en el anterior tile de vida del tilemap
;;;; A viewportHealthVideo   , lo posiciona en el anterior tile de vida de la memoria de video
;;;; A viewportHealthAmount  , le quita uno
;;;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX, IY
;;;; ENTRADA: -
;;;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ren_removeHealthViewport:       ;; copiado y pegado de player_add_health
    ;; Primero cambiamos variables y luego dibujamos tile contenedor
    ld      hl, (viewportHealthTilemap)        ;; Guardamos posicion donde dibujaría siguiente vida
    ld      a, (viewportHealthAmount)
    sub     #5                                 ;; Si esta en 5 y quitamos una vida. Nos desplazamos arriba
    jr      z, changeUp
    dec     hl                                 ;; redibujar en tile a la izquierda
    ld  (viewportHealthTilemap), hl            ;; guardamos tile a la izquierda
    ld      hl, (viewportHealthVideo)          ;; Posicion en memoria un tile a la izquierda
    ld      bc, #-4
    add     hl, bc
    ld  (viewportHealthVideo), hl              ;; Posicion en memoria un tile a la izquierda
    jr      notChangeUp
changeUp:
    ld      (hl), #tile_borde_viewport         ;; Para reajustar tile actual
    ld      bc, #_viewport_W
    add     hl, bc 
    ld      bc, #5
    add     hl, bc
    ld  (viewportHealthTilemap), hl             ;; Guardamos posicion un tile arriba y 5 hacia adelante. Es el salto de 6 a 5 vidas
    ld      hl, #viewport_video_changeUp        ;; Cambio a posicion de memoria correcta                         
    ld  (viewportHealthVideo), hl               ;; Posicion donde dibujariamos vida 5
notChangeUp:
    ;; comun a los dos casos
    ld      a, (viewportHealthAmount)
    dec     a 
    ld  (viewportHealthAmount), a               ;; Quitamos uno al contador de vida

    ld      hl, (viewportHealthTilemap)        ;; Guardamos posicion donde dibujaría siguiente vida
    ld      (hl), #spriteContenedor            ;; Cambiamos tileSet del viewport

    ;;          C  -> Anchura en tiles de vista a dibujar
    ;;          B  -> Altura en tiles de vista a dibujar
    ;;          DE -> Anchura en tiles del tilemap que vamos a usar
    ld      bc, #0x0101
    ld      de, #_viewport_W
    call    ren_setDrawMap      ;; Destruye AF, DE, HL

    ;;          DE -> Puntero a parte del tilemap a usar
    ;;          HL -> Puntero a posicion donde vamos a dibujar en pantalla
    ld      de, (viewportHealthTilemap)
    ld      hl, (viewportHealthVideo)
    ld      c, #1               ;; 1 = dibujar back_buffer
    call    ren_drawMap         ;; Destruye AF, BC, DE, HL, IX, IY

    ;;      Tiene que estar en el  
    ld      de, (viewportHealthTilemap)
    ld      hl, (viewportHealthVideo)
    ld      c, #0               ;; 0 = dibujar front_buffer
    call    ren_drawMap         ;; Destruye AF, BC, DE, HL, IX, IY

    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Dibuja la vida nueva y modifica las variables
;; relacionadas con la vida.
;; A viewportHealthTilemap , lo posiciona en el proximo tile de vida del tilemap
;; A viewportHealthVideo   , lo posiciona en el proximo tile de vida de la memoria de video
;; A viewportHealthAmount  , le añade uno
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX, IY
;; ENTRADA: -
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ren_modifyKeyViewport:
    dec     a
    jr      z, skipChange
    ld      a, #spriteFondoViewport
    ld  (switchToBackground), a
    jr      changeDone
skipChange:  
    ld      a, #spriteLlave
    ld  (switchToBackground), a
changeDone:

    ;; Primero cambiamos tileset y dibujamo y luego cambiamos variables
    ld      hl, #viewportKeyTileMapPos        ;; Guardamos posicion donde dibujaría siguiente vida
    switchToBackground = . + 1
    ld      (hl), #spriteLlave                 ;; Por defecto esta la llave, pero si esta A a 0 lo cambiamos al tile de fondo

    ;;          C  -> Anchura en tiles de vista a dibujar
    ;;          B  -> Altura en tiles de vista a dibujar
    ;;          DE -> Anchura en tiles del tilemap que vamos a usar
    ld      bc, #0x0101
    ld      de, #_viewport_W
    call    ren_setDrawMap  ;; Destruye AF, DE, HL

    ;;          DE -> Puntero a parte del tilemap a usar
    ;;          HL -> Puntero a posicion donde vamos a dibujar en pantalla
    ld      de, #viewportKeyTileMapPos
    ld      hl, #viewportKeyVideo
    ld      c, #1           ;; 1 = dibujar back_buffer
    call    ren_drawMap     ;; Destruye AF, BC, DE, HL, IX, IY

    ;;          DE -> Puntero a parte del tilemap a usar
    ;;          HL -> Puntero a posicion donde vamos a dibujar en pantalla
    ld      de, #viewportKeyTileMapPos
    ld      hl, #viewportKeyVideo
    ld      c, #0           ;; 0 = dibujar front_buffer
    call    ren_drawMap     ;; Destruye AF, BC, DE, HL, IX, IY
    
    ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Dibuja el daño nuevo y modifica las variables
;; relacionadas con el daño.
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL, IX, IY
;; ENTRADA: -
;; SALIDA:  -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ren_addStrengthViewport:
;; Primero cambiamos tileset y dibujamos y luego cambiamos variables
    ld      hl, (viewportSMGTileMapPos)        ;; Guardamos posicion donde dibujaría siguiente vida
    ld      (hl), #spriteMetralleta                  ;; Cambiamos tileSet del viewport

    ;;          C  -> Anchura en tiles de vista a dibujar
    ;;          B  -> Altura en tiles de vista a dibujar
    ;;          DE -> Anchura en tiles del tilemap que vamos a usar
    ld      bc, #0x0101
    ld      de, #_viewport_W
    call    ren_setDrawMap  ;; Destruye AF, DE, HL

    ;;          DE -> Puntero a parte del tilemap a usar
    ;;          HL -> Puntero a posicion donde vamos a dibujar en pantalla
    ld      de, (viewportSMGTileMapPos)
    ld      hl, (viewportSMGVideo)
    ld      c, #1           ;; 1 = dibujar back_buffer
    call    ren_drawMap     ;; Destruye AF, BC, DE, HL, IX, IY


    ld      de, (viewportSMGTileMapPos)
    ld      hl, (viewportSMGVideo)
    ld      c, #0           ;; 0 = dibujar front_buffer
    call    ren_drawMap     ;; Destruye AF, BC, DE, HL, IX, IY
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    ld      hl, (viewportSMGTileMapPos)         ;; Guardamos posicion donde dibujaría siguiente vida
    inc     hl                                  ;; Dibujar a la deracha
    ld  (viewportSMGTileMapPos), hl             ;; guardamos tile a la derecha
    ld      hl, (viewportSMGVideo)           
    ld      bc, #4
    add     hl, bc
    ld  (viewportSMGVideo), hl               ;; Posicion en memoria un tile a la derecha

    ret

;;;;;;;;;;;;;;; VIEWPORT FINISHED ;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Recibe el puntero al nivel y la posicion X e Y de 
;; cualquier drawable. Ej: player, bullet, enemy, etc
;; Devuelve la posicion del nivel en la que se encuentra
;; el drawable, si la posicion esta alineado con el tile o no
;; en X, Y y el offset desde la posicion X,Y pasada al tile en
;; el que se encuentra.
;; 
;; Cada tile se recorre restando 8 bytes/pixeles en vertical y
;; 4 bytes/16 pixeles en horizontal.
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL
;; ENTRADA: 
;;          A -> Posicion Y
;;          C -> Posicion X
;;          HL-> Puntero al nivel
;; SALIDA:
;;          HL-> Puntero al tile donde se encuentra la X e Y pasada
;;          D -> 0 Cuando no esta alineado, 1 cuando lo esta ( Eje Y)
;;          E -> 0 Cuando no esta alineado, 1 cuando lo esta ( Eje X)
;;          A -> Offset del tile en Y
;;          B -> Offset del tile en X
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ren_getLevelPos:
    ;; Primera vamos a desplazarnos de arriba hacia abajo.
    ld      b, #0               ;; Contador de tiles movidos
    ld      de, #0              ;; Reseteamos bools de alineacion

    ;; El registro a puede llegar a ser negativo. Un valor posible es 0x88.
    ;; En estos casos no podemos usar jp p, por lo que miramos si el primer
    ;; nibble es F. Así aseguramos la transición de positivo a negativo
    keepSub1:
    ;; Checkeo para ver si la resta ha pasado de numero positivo a negativo.
    ;; Por ejemplo, de 0x02 a 0xFA. 2(0x02) - 8 = -6(FA) 
    bit     4, a            
    jr      z, SubPos
    bit     5, a
    jr      z, SubPos
    bit     6, a
    jr      z, SubPos
    bit     7, a
    jr      z, SubPos
    ;; Si primer nibble es F hemos acabado
    jr      endKeepSub

    SubPos:
    inc     b                   ;; Incrementamos contador
    sub     #8                  ;; A = A - 8    ;; 8 ya que cada tile son 8 pixeles de alto
    jr      nz, keepSub1        ;; Si es 0 añadimos 1 para saber que es alineado
    inc     d                   ;; Alineado
    jr      keepSub1        
endKeepSub:

    add     #8                  ;; añadimos 8 para dejar offset del tile positivo
    push    af                  ;; metemos en el stack el offset de Y

    dec     b                   ;; Reseteamos b a los tiles que tiene que desplazarse.
    jr      z, skipSum1		    ;; si B es ZERO es porque al hacer la primera resta da negativo y no sumamos

    push    de                  ;; guardamos registro d para no perder la alineacion
    ld      de, #_rooms1_W      ;; Para desplazarnos abajo hay que sumar el ancho 
    
    keepSum1:                   ;; Sumamos a hl multiplicación de: altura en la que se encuentra el tile * Anchura tilemap
    add     hl, de              ;; Sumamos el numero de veces b a hl
    dec     b 
    jr      nz, keepSum1        ;; HL = HL + B * _rooms1_w

    pop     de                  ;; Restauramos valor de alineacion

    skipSum1:
    ld      a, c                ;; A = Posicion X jugador
    ld      bc, #0              ;; En este caso uso bc ya que puedo sumarlo directamente a hl      
    
    keepSub2:                   ;; En este caso nos sirve jp p, ya que el rango de x es (0-79)
    inc     bc 
    sub     #4                  ;; A = A - 4 
    jp      p, keepSub2         ;; Si es positivo seguimos restando a A

    add     #4                  ;; Para ver si ultimo era 0 y dejar offset positivo
    jr      nz, notAligned      ;; Si es 0 añadimos 1 para saber que es alineado
    inc     e                   ;; Alineado en x
    notAligned:
    
    dec     bc                  ;; Reset B
    add     hl, bc              ;; hl = hl + bc

    ld      b, a                ;; B = offset en X
    pop     af                  ;; A = offset en Y
    ret
